{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 BBS Dialog Unit                                                   }
{                                                                             }
{ 2001-05 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Bbsdlg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, Buttons, ShellApi;

type
  TBBSDialog = class(TForm)
    Image2: TImage;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    CheckBox1: TCheckBox;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    Shape1: TShape;
    Image3: TImage;
    Panel1: TPanel;
    Button2: TButton;
    Button1: TButton;
    Shape2: TShape;
    Label3: TLabel;
    Label4: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Label2Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private 錾 }
    FIndex : integer;
    procedure ShowBBS;
  public
    { Public 錾 }
  end;

var
  BBSDialog: TBBSDialog;

implementation

{$R *.dfm}

uses
  ZonuConf, Hzbconst, ZonuClass;

procedure TBBSDialog.FormCreate(Sender: TObject);
begin
  FIndex  :=  0;
  ShowBBS;

end;

procedure TBBSDialog.ShowBBS;
var
  Site :  TSite;
  s : string;
  c : TStringList;
begin
  Site  :=  ZonuEnviron.SiteList[FIndex];
  CheckBox1.Checked :=  Site.IsSubscription;
  s :=  ZonuConfig.AppPath + PATH_SITE_CONFIG + Site.SiteID + '\' + FILE_BBS_ICON;
  if  (FileExists(s)) then  begin
    Image1.Picture.LoadFromFile(s);
  end else begin
    Image1.Picture.Assign(Image2.Picture);
  end;
  s :=  ZonuConfig.AppPath + PATH_SITE_CONFIG + Site.SiteID + '\' + FILE_BBS_BACK;
  if  (FileExists(s)) then  begin
    Image3.Picture.LoadFromFile(s);
  end else begin
    Image3.Picture  :=  nil;
  end;
  Label1.Caption    :=  Site.SiteName;
  Label2.Caption    :=  Site.Url;
  s :=  ZonuConfig.AppPath + PATH_SITE_CONFIG + Site.SiteID + '\' + FILE_BBS_COMMENT;
  if  (FileExists(s)) then  begin
    c :=  TStringList.Create;
    c.LoadFromFile(s);
    Label3.Caption  :=  c.Text;
    c.Free;
  end else begin
    Label3.Caption  :=  '';
  end;
end;

procedure TBBSDialog.SpeedButton2Click(Sender: TObject);
begin
  Inc(FIndex);
  if  (FIndex > ZonuEnviron.SiteList.Count - 1)  then  FIndex  :=  0;

  if  (ZonuEnviron.SiteList[FIndex] = ZonuEnviron.FavoritesSite)  or
      (ZonuEnviron.SiteList[FIndex] = ZonuEnviron.LocalSite)  or
      (ZonuEnviron.SiteList[FIndex] = ZonuEnviron.UserSite)  then
  begin
    SpeedButton2Click(Sender);
  end;
  
  ShowBBS;
end;

procedure TBBSDialog.SpeedButton1Click(Sender: TObject);
begin
  Dec(FIndex);
  if  (FIndex < 0)  then  FIndex  :=  ZonuEnviron.SiteList.Count - 1;

  if  (ZonuEnviron.SiteList[FIndex] = ZonuEnviron.FavoritesSite)  or
      (ZonuEnviron.SiteList[FIndex] = ZonuEnviron.LocalSite)  or
      (ZonuEnviron.SiteList[FIndex] = ZonuEnviron.UserSite)  then
  begin
    SpeedButton1Click(Sender);
  end;

  ShowBBS;
end;

procedure TBBSDialog.Label2Click(Sender: TObject);
begin
  ShellExecute(Handle,
               'open',
               PChar(ZonuEnviron.SiteList[FIndex].Url),
               '', '', SW_SHOW);
end;

procedure TBBSDialog.CheckBox1Click(Sender: TObject);
begin
  ZonuEnviron.SiteList[FIndex].IsSubscription  :=  CheckBox1.Checked;
end;

procedure TBBSDialog.Button2Click(Sender: TObject);
begin
  ModalResult :=  mrOk;
end;

procedure TBBSDialog.Button1Click(Sender: TObject);
begin
  ModalResult :=  mrCancel;
end;

end.
