{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 Chotto Browser Unit                                               }
{                                                                             }
{ 2001-05 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Chotto;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, OleCtrls, SHDocVw, EmbeddedWB, StdCtrls, ExtCtrls;

type
  TChottoWindow = class(TForm)
    StatusBar1: TStatusBar;
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Edit1: TEdit;
    EmbeddedWB1: TEmbeddedWB;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure EmbeddedWB1NewWindow2(Sender: TObject; var ppDisp: IDispatch;
      var Cancel: WordBool);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    FResultCode: integer;
    function GetUrl: string;
    procedure SetUrl(const Value: string);
    { Private 錾 }
  public
    { Public 錾 }
    property  Url: string   read  GetUrl  write SetUrl;
    property  ResultCode: integer read  FResultCode;
  end;

var
  ChottoWindow: TChottoWindow;

implementation

{$R *.dfm}

uses
  ZonuConf;

{ TChottoWindow }

function TChottoWindow.GetUrl: string;
begin
  Result  :=  Edit1.Text;
end;

procedure TChottoWindow.SetUrl(const Value: string);
begin
  Edit1.Text  :=  Value;  
end;

procedure TChottoWindow.FormCreate(Sender: TObject);
begin
  FResultCode :=  0;
end;

procedure TChottoWindow.Button1Click(Sender: TObject);
begin
  EmbeddedWB1.Navigate('about:blank');
  FResultCode :=  1;
  Close;
end;

procedure TChottoWindow.Button2Click(Sender: TObject);
begin
  EmbeddedWB1.Navigate('about:blank');
  FResultCode :=  2;
  Close;
end;

procedure TChottoWindow.Button3Click(Sender: TObject);
begin
  EmbeddedWB1.Navigate('about:blank');
  FResultCode :=  0;
  Close;
end;

procedure TChottoWindow.FormShow(Sender: TObject);
begin
  WindowState :=  ZonuConfig.ChottoWindowState;
  if  (WindowState = wsNormal)  then  begin
    Self.SetBounds( ZonuConfig.ChottoPosLeft,
                    ZonuConfig.ChottoPosTop,
                    ZonuConfig.ChottoWidth,
                    ZonuConfig.ChottoHeight);
  end;
  EmbeddedWB1.Navigate(Url);
end;

procedure TChottoWindow.EmbeddedWB1NewWindow2(Sender: TObject;
  var ppDisp: IDispatch; var Cancel: WordBool);
begin
  Cancel  :=  True;
  MessageDlg('ƌr[[ł̓N\ł܂B' + #13#10 +
             '[zbg]kŊJ] ܂ [uEUŊJ] NbNĉB',
             mtInformation, [mbOk], 0);
end;

procedure TChottoWindow.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  ZonuConfig.ChottoWindowState :=  WindowState;
  if  (WindowState = wsNormal)  then  begin
    ZonuConfig.ChottoPosLeft :=  Left;
    ZonuConfig.ChottoPosTop  :=  Top;
    ZonuConfig.ChottoWidth   :=  Width;
    ZonuConfig.ChottoHeight  :=  Height;
  end;
end;

end.
