{ *************************************************************************** }
{                                                                             }
{ Hotzonu Direct Dialog Unit                                                  }
{                                                                             }
{ 2001-04 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Hzbdirect;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, Dlghead, HttpProt, Menus, Buttons, StdCtrls, ExtCtrls;

type
  TDirectDialog = class(TForm)
    StatusBar1: TStatusBar;
    TreeView1: TTreeView;
    HttpCli1: THttpCli;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    Panel1: TPanel;
    HeaderIcon: TImage;
    HeaderLabel: TLabel;
    SpeedButton1: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private 錾 }
    FHttpStream : TMemoryStream;
    procedure BuildTree;
  public
    { Public 錾 }
    procedure Download;
  end;

var
  DirectDialog: TDirectDialog;

implementation

{$R *.dfm}

uses
  Zonuconf, Hzbconst, Main;

procedure TDirectDialog.FormCreate(Sender: TObject);
begin
  BuildTree;
end;

procedure TDirectDialog.BuildTree;
begin
  TreeView1.Items.Clear;
  if  (FileExists(ZonuConfig.UsersPath + FILE_HZB_DIRECT))  then  begin
    TreeView1.LoadFromFile(ZonuConfig.UsersPath + FILE_HZB_DIRECT);
    if  (TreeView1.Items.Count > 0) then  begin
      TreeView1.Items[0].Expand(False);
      if  (TreeView1.Items[0].HasChildren)  then  begin
        TreeView1.Items[0].Item[0].Expand(True);
      end;
    end;
  end;
end;

procedure TDirectDialog.N1Click(Sender: TObject);
begin
  Download;
end;

procedure TDirectDialog.Download;
begin
  FHttpStream   :=  TMemoryStream.Create;
  if  (ZonuConfig.ProxyUse) then  begin
    HttpCli1.Proxy          :=  ZonuConfig.Proxy;
    HttpCli1.ProxyPort      :=  ZonuConfig.ProxyPort;
    HttpCli1.ProxyUsername  :=  ZonuConfig.ProxyUserName;
    HttpCli1.ProxyPassword  :=  ZonuConfig.ProxyPassword;
  end;
  HttpCli1.Agent            :=  USER_AGENT;
  FHttpStream.Position      :=  0;
  FHttpStream.Size          :=  0;
  HttpCli1.RcvdStream       :=  FHttpStream;
  HttpCli1.NoCache          :=  True;
  HttpCli1.URL              :=  URL_HOTZONU_INFO + FILE_HZB_DIRECT;
  HotzonuWindow.Memo1.Lines.Add('ł...');
  Screen.Cursor             :=  crHourGlass;
  TreeView1.Color           :=  cl3DLight;
  HttpCli1.Get;
  if  (HttpCli1.StatusCode = 200) then  begin
    HotzonuWindow.Memo1.Lines.Add('emFEEE');
    FHttpStream.SaveToFile(ZonuConfig.UsersPath + FILE_HZB_DIRECT);
    BuildTree;
  end;
  TreeView1.Color           :=  clWindow;
  Screen.Cursor             :=  crDefault;
end;

procedure TDirectDialog.FormShow(Sender: TObject);
begin
  StatusBar1.Panels[0].Text :=  FormatDateTime('yyyy/mm/dd', now);
  if  (ZonuConfig.StartUpLoadDirect)  then  begin
    N1.Click;
  end;
end;

end.
