{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 NG Word Dialog Unit                                               }
{                                                                             }
{ 2001-02 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Ngdlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls, ExtCtrls, Main, IniFiles, Hzbconst,
  MonaUtils, ZonuClass, Menus, ToolWin, ActnList, Clipbrd, ImgList;

type
  TNGWordDialog = class(TForm)
    PopupMenu1: TPopupMenu;
    ControlBar1: TControlBar;
    ToolBar1: TToolBar;
    ActionList1: TActionList;
    actAdd: TAction;
    actEdit: TAction;
    actDelete: TAction;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    actPaste: TAction;
    actCopy: TAction;
    ToolButton6: TToolButton;
    N1: TMenuItem;
    E1: TMenuItem;
    Delete1: TMenuItem;
    N2: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    SpeedButton1: TSpeedButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Panel1: TPanel;
    TreeView1: TTreeView;
    Panel3: TPanel;
    ListView1: TListView;
    Splitter1: TSplitter;
    Panel2: TPanel;
    CheckBox1: TCheckBox;
    Panel4: TPanel;
    TreeView2: TTreeView;
    Panel5: TPanel;
    ComboBox1: TComboBox;
    Shape1: TShape;
    Panel6: TPanel;
    StatusBar1: TStatusBar;
    ProgressBar1: TProgressBar;
    ImageList1: TImageList;
    Panel7: TPanel;
    Panel8: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TreeView2Change(Sender: TObject; Node: TTreeNode);
    procedure CheckBox1Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure actAddExecute(Sender: TObject);
    procedure actEditExecute(Sender: TObject);
    procedure actDeleteExecute(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure actPasteExecute(Sender: TObject);
    procedure actCopyExecute(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private 錾 }
    procedure BuildNGWord;
    procedure BuildBoardList;
  public
    { Public 錾 }
    procedure Init;
  end;
         {
     ^PPPP_
   ^               __________________________
   |Y   Y         _   ^
   ||   |        | @{[hꗗc[p̍\
   | _^     __l_|   ___________________________
   |         _____m
    _@@ ^
     b b |
    i___)__}

  PNodeData = ^TNodeData;
  TNodeData = record
    SiteID    : string;
    BoardID   : string;
    Name      : string;
    Url       : string;
    IsAll     : boolean;
  end;

var
  NGWordDialog: TNGWordDialog;

implementation

{$R *.DFM}

uses
  ZonuConf, Hzbclass, Ngword, Ngdlg2;

var
  AppPath : string;
  NGWordList  : TNGWordList;
  FCopyNGWord : TNGWord;

procedure TNGWordDialog.FormCreate(Sender: TObject);
begin
  AppPath         :=  ExtractFilePath(Application.ExeName);
  NGWordDialog2   :=  TNGWordDialog2.Create(Self);
  NGWordList      :=  TNGWordList.Create;
  ComboBox1.Align :=  alClient;
  FCopyNGWord     :=  TNGWord.Create;
end;

procedure TNGWordDialog.FormDestroy(Sender: TObject);
begin
  NGWordDialog2.Free;
  //NGWordList.SaveToFile(AppPath + FILE_NGWORD);
  NGWordList.SaveToFile(ZonuConfig.UsersPath + FILE_NG_WORD);
  NGWordList.Free;
  FCopyNGWord.Free;
end;

// ^             ^PPPPPPPPPPPPPP
// |Y   Y           NG[h̃c[\z
// ||   |       l|   _____________________________
procedure TNGWordDialog.BuildNGWord;
var
  NGNode  : TTreeNode;
  Node    : TTreeNode;
  Site    : TSite;
  Board   : TBoard;
  i, x : integer;
begin
  TreeView1.Items.Clear;
  for i :=  0 to  NGWordList.Count - 1  do  begin
    NGNode  :=  TreeView1.Items.AddChild(nil, NGWordList[i].Text);
    NGNode.ImageIndex     :=  19;
    NGNode.SelectedIndex  :=  19;
    NGNode.Data           :=  NGWordList[i];
    for x :=  0 to  NGWordList[i].TargetBoardList.Count - 1 do  begin
      if  (NGWordList[i].TargetBoardList[x].IsAll)  then  begin
        Node  :=  TreeView1.Items.AddChild(NGNode, '[ׂĂ̔]');
        Node.ImageIndex     :=  7;
        Node.SelectedIndex  :=  8;
        Node.Data :=  NGWordList[i].TargetBoardList[x];
      end else begin
        if  (ZonuEnviron.SiteList.FindSite(NGWordList[i].TargetBoardList[x].SiteID, Site)) then  begin
          if  (Site.BoardList.FindBoard(NGWordList[i].TargetBoardList[x].BoardID, Board))  then  begin
            Node  :=  TreeView1.Items.AddChild(NGNode, Board.Name);
            Node.ImageIndex     :=  14;
            Node.SelectedIndex  :=  14;
            Node.Data :=  NGWordList[i].TargetBoardList[x];
          end;
        end;
      end;
    end;
  end;
end;

//  PPPPPPPPPPPPPPPPPPPPPPPPPPP_            _
//  {[hꗗ̃c[                                              Y   Y|
//  ______________________________________________________^   |l      |   ||
procedure TNGWordDialog.BuildBoardList;
  procedure _BuildBoardList(Site: TSite; BoardName: string; BoardList: TBoardList);
  var
    NGWord  : TStringList;
    ParentNode, CategoryNode, Node: TTreeNode;
    NodeData : PNodeData;
    CategoryName : string;
    i : integer;
  begin
    NGWord    :=  TStringList.Create;
    if  (FileExists(ZonuConfig.UsersPath + FILE_NG_WORD)) then  begin
      NGWord.LoadFromFile(ZonuConfig.UsersPath + FILE_NG_WORD);
    end;
    ParentNode  :=  TreeView2.Items.AddChild(nil , BoardName);
    ParentNode.ImageIndex     :=  Site.ImageIndex;
    ParentNode.SelectedIndex  :=  Site.ImageIndex;
    ParentNode.Data :=  nil;
    CategoryNode    :=  ParentNode;
    CategoryName    :=  '';
    for i :=  0 to  BoardList.Count - 1 do  begin
      if  (CategoryName <> BoardList[i].CategoryName) then  begin
        CategoryName  :=  BoardList[i].CategoryName;
        CategoryNode  :=  TreeView2.Items.AddChild(ParentNode, CategoryName);
        CategoryNode.ImageIndex     :=  7;
        CategoryNode.SelectedIndex  :=  8;
        CategoryNode.Data :=  nil;
      end;
      Node  :=  TreeView2.Items.AddChild(CategoryNode, BoardList[i].Name);
      if  (AnsiPos(BoardList[i].Site.SiteID,  NGWord.Text) > 0) and
          (AnsiPos(BoardList[i].BoardID, NGWord.Text) > 0) then
      begin
        Node.ImageIndex     :=  15;
        Node.SelectedIndex  :=  15;
        ComboBox1.Items.Objects[ComboBox1.Items.Add(BoardList[i].Name)] :=  BoardList[i];
      end else begin
        Node.ImageIndex     :=  14;
        Node.SelectedIndex  :=  14;
      end;
      New(NodeData);
      NodeData.SiteID     :=  BoardList[i].Site.SiteID;
      NodeData.BoardID    :=  BoardList[i].BoardID;
      NodeData.Name       :=  BoardList[i].Name;
      NodeData.Url        :=  BoardList[i].Url;
      NodeData.IsAll      :=  False;
      Node.Data           :=  NodeData;
      ProgressBar1.StepIt;
    end;
    NGWord.Free;
  end;
var
  Node    : TTreeNode;
  NodeData : PNodeData;
  i, n : integer;
begin
  ProgressBar1.Min  :=  0;
  n := 0;
  for i :=  0 to  ZonuEnviron.SiteList.Count - 1 do  begin
    n :=  n + ZonuEnviron.SiteList[i].BoardList.Count;
  end;
  ProgressBar1.Max      :=  n;
  ProgressBar1.Position :=  0;
  ProgressBar1.Step     :=  1;

  TreeView2.Items.BeginUpdate;
  TreeView2.Items.Clear;
  for i :=  0 to  ZonuEnviron.SiteList.Count - 1 do  begin
    _BuildBoardList(ZonuEnviron.SiteList[i],
                    ZonuEnviron.SiteList[i].SiteName,
                    ZonuEnviron.SiteList[i].BoardList);
  end;
  TreeView2.Items.EndUpdate;

  Node  :=  TreeView2.Items.AddChild(nil, '[ׂ]');
  Node.ImageIndex     :=  7;
  Node.SelectedIndex  :=  8;
  New(NodeData);
  NodeData.SiteID     :=  '#ALL';
  NodeData.BoardID    :=  '#ALL';
  NodeData.Name       :=  'ׂ';
  NodeData.Url        :=  '#ALL';
  NodeData.IsAll      :=  True;
  Node.Data           :=  NodeData;
  ProgressBar1.Position :=  0;
end;

// ^             ^PPPPPPPPPPPPPP
// |Y   Y           {[hꗗ̃c[I񂾂Ƃ̏
// ||   |       l|   _____________________________
procedure TNGWordDialog.TreeView2Change(Sender: TObject; Node: TTreeNode);
var
  i, x  : integer;
  Item  : TListItem;
  b : boolean;
begin
  ListView1.Items.Clear;
  if  (Node <> nil) then  begin
    if  (Node.Data <> nil)  then  begin
      for i :=  0 to  NGWordList.Count - 1  do  begin
        for x :=  0 to  NGWordList.Items[i].TargetBoardList.Count - 1 do  begin
          b :=  False;
          if  (PNodeData(Node.Data).SiteID =  NGWordList.Items[i].TargetBoardList[x].SiteID) and
              (PNodeData(Node.Data).BoardID =  NGWordList.Items[i].TargetBoardList[x].BoardID)  then
          begin
            b :=  True;
          end;

          if  (NGWordList.Items[i].TargetBoardList[x].IsAll) and (not CheckBox1.Checked) then  b :=  True;
          if  (PNodeData(Node.Data).IsAll) and (NGWordList.Items[i].TargetBoardList[x].IsAll) then  b :=  True;
          if  (b) then  begin
            Item  :=  ListView1.Items.Add;
            Item.Caption    :=  NGWordList.Items[i].Text;
            Item.ImageIndex :=  19;
            Item.Data       :=  NGWordList.Items[i];
            if  (not PNodeData(Node.Data).IsAll) and (NGWordList.Items[i].TargetBoardList[x].IsAll) then  begin
              Item.Cut  :=  True;
            end;
          end;
        end;
      end;
    end;
  end;
end;

procedure TNGWordDialog.CheckBox1Click(Sender: TObject);
begin
  TreeView2.OnChange(TreeView2, TreeView2.Selected);
end;

procedure TNGWordDialog.ComboBox1Change(Sender: TObject);
var
  i : integer;
begin
  if  (ComboBox1.Items.Objects[ComboBox1.ItemIndex] <>  nil)  then  begin
    for i :=  0 to  TreeView2.Items.Count - 1 do  begin
      if  (TreeView2.Items[i].Data <> nil)  then  begin
        if  (PNodeData(TreeView2.Items[i].Data).SiteID = TBoard(ComboBox1.Items.Objects[ComboBox1.ItemIndex]).Site.SiteID) and
            (PNodeData(TreeView2.Items[i].Data).BoardID = TBoard(ComboBox1.Items.Objects[ComboBox1.ItemIndex]).BoardID)  then
        begin
          TreeView2.Selected  :=  TreeView2.Items[i];
          Break;
        end;
      end;
    end;
  end;
end;

//  PPPPPPPPPPPPPPPPPPPPPPPPPPP_            _
//  VKǉ̑O                                                Y   Y|
//  ______________________________________________________^   |l      |   ||
procedure TNGWordDialog.actAddExecute(Sender: TObject);
var
  ANGWord : TNGWord;
  Browser : TZonuBrowser;
  ListDoc : TZonuListDoc;
begin
  ANGWord :=  TNGWord.Create;
  if  (PageControl1.ActivePageIndex = 1)  then  begin
    if  (TreeView2.Selected <> nil) then  begin
      if  (TreeView2.Selected.Data <> nil) then  begin
        NGWordDialog2.Add(ANGWord,
                          PNodeData(TreeView2.Selected.Data).SiteID,
                          PNodeData(TreeView2.Selected.Data).BoardID);
      end else begin
        NGWordDialog2.Add(ANGWord, '', '');
      end;
    end else begin
      NGWordDialog2.Add(ANGWord, '', '');
    end;
  end else begin
    if  (HotzonuWindow.GetActiveBrowser(Browser))  then  begin
      NGWordDialog2.Add(ANGWord, Browser.Board.Site.SiteID, Browser.Board.BoardID);
    end else
    if  (HotzonuWindow.GetActiveListDoc(ListDoc))  then  begin
      NGWordDialog2.Add(ANGWord, ListDoc.Board.Site.SiteID, ListDoc.Board.BoardID);
    end else begin
      NGWordDialog2.Add(ANGWord, '', '');
    end;
  end;
  /////////////////////////////////////////////////
  SetWindowPos(Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
  if  (NGWordDialog2.ShowModal = mrOk)  then  begin
    NGWordList.Add(ANGWord);
    if  (PageControl1.ActivePageIndex = 0)  then  begin
      TreeView1.Items.Clear;
      BuildNGWord;
    end else begin
      TreeView2.OnChange(Self,  TreeView2.Selected);
    end;
  end else begin
    ANGWord.Free;
  end;
  SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
end;

//  PPPPPPPPPPPPPPPPPPPPPPPPPPP_            _
//  mf[hC̑O                                          Y   Y|
//  ______________________________________________________^   |l      |   ||
procedure TNGWordDialog.actEditExecute(Sender: TObject);
begin
  if  (PageControl1.ActivePageIndex = 1)  then  begin
    if  (ListView1.Selected <> nil) then  begin
      NGWordDialog2.Edit(TNGWord(ListView1.Selected.Data));
    end else begin
      Exit;
    end;
  end else begin
    if  (TreeView1.Selected <> nil) then  begin
      if  (TreeView1.Selected.Level = 0) then  begin
        NGWordDialog2.Edit(TNGWord(TreeView1.Selected.Data));
      end else begin
        NGWordDialog2.Edit(TNGWord(TreeView1.Selected.Parent.Data));
      end;
    end else begin
      Exit;
    end;
  end;
  /////////////////////////////////////////////////
  SetWindowPos(Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
  if  (NGWordDialog2.ShowModal = mrOk)  then  begin
    if  (PageControl1.ActivePageIndex = 0)  then  begin
      TreeView1.Items.Clear;
      BuildNGWord;
    end else begin
      TreeView2.OnChange(Self,  TreeView2.Selected);
    end;
  end;
  SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
end;

          {
    ^PPPPP _
   /               _
  /           ( j |
 | |( j   ]-]b |    ^PPPPPPPPPPPPPPPPPPPP
 | b-]       b |Q/@@@` [[[[[[
 _/ ^      __/  b      _______________________________________
     |__P  |  /________m
        b/Pb/_          m
         ___/    P
                /////////////}


procedure TNGWordDialog.actDeleteExecute(Sender: TObject);
var
  ANGWord : TNGWord;
  i : integer;
begin
  ANGWord :=  nil;
  if  (PageControl1.ActivePageIndex = 0)  then  begin
    if  (TreeView1.Selected <> nil) then  begin
      if  (TreeView1.Selected.Level = 0)  then  begin
        ANGWord :=  TNGWord(TreeView1.Selected.Data);
      end else begin
        ANGWord :=  TNGWord(TreeView1.Selected.Parent.Data);
      end;
    end;
  end else begin
    if  (ListView1.Selected <> nil) then  begin
      ANGWord :=  TNGWord(ListView1.Selected.Data);
    end;
  end;
  
  if  (ANGWord <> nil)  then  begin
    SetWindowPos(Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
    if  (MessageDlg('폜܂H' + #13#10 +
                    ANGWord.Text, mtWarning, [mbYes, mbNo], 0) = mrYes)  then
    begin
      for i :=  0 to  NGWordList.Count - 1  do  begin
        if  (NGWordList[i] = ANGWord) then  begin
          NGWordList[i].TargetBoardList.Clear;
          NGWordList.Delete(i);
          Break;
        end;
      end;
      if  (PageControl1.ActivePageIndex = 0)  then  begin
        BuildNGWord;
      end else begin
        TreeView2.OnChange(Self, TreeView2.Selected);
      end;
    end;
    SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
  end;
end;

procedure TNGWordDialog.SpeedButton1Click(Sender: TObject);
begin
  NGWordList.SaveToFile(ZonuConfig.UsersPath + FILE_NG_WORD);
  HotzonuWindow.RefreshThread;
end;

procedure TNGWordDialog.PageControl1Change(Sender: TObject);
begin
  NGWordList.SaveToFile(ZonuConfig.UsersPath + FILE_NG_WORD);
  if  (PageControl1.ActivePageIndex = 0)  then  begin
    BuildNGWord;
  end else begin
    TreeView2.OnChange(TreeView2, TreeView2.Selected);
  end;
end;

procedure TNGWordDialog.actCopyExecute(Sender: TObject);
begin
  if  (PageControl1.ActivePageIndex = 0)  then  begin
    if  (TreeView1.Selected <> nil) then  begin
      if  (TreeView1.Selected.Level = 0)  then  begin
        FCopyNGWord.Assign(TNGWord(TreeView1.Selected.Data));
      end else begin
        FCopyNGWord.Assign(TNGWord(TreeView1.Selected.Parent.Data));
      end;
    end;
  end else begin
    if  (ListView1.Selected <> nil) then  begin
      FCopyNGWord.Assign(TNGWord(ListView1.Selected.Data));
    end;
  end;
end;

procedure TNGWordDialog.actPasteExecute(Sender: TObject);
var
  ANGWord : TNGWord;
  ATargetBoard : TTargetBoard;
begin
  if  (FCopyNGWord <> nil)  then  begin
    if  (FCopyNGWord.Text <> '')  then  begin
      ANGWord :=  TNGWord.Create;
      ANGWord.Assign(FCopyNGWord);
      NGWordList.Add(ANGWord);
      if  (PageControl1.ActivePageIndex = 1)  then  begin
        if  (TreeView2.Selected <> nil) then  begin
          if  (TreeView2.Selected.Data <> nil)  then  begin
            ATargetBoard  :=  TTargetBoard.Create;
            if  (PNodeData(TreeView2.Selected.Data).IsAll)  then  begin
              ATargetBoard.SiteID   :=  '#ALL';
              ATargetBoard.BoardID  :=  '#ALL';
              ATargetBoard.IsAll    :=  True;
            end else begin
              ATargetBoard.SiteID   :=  PNodeData(TreeView2.Selected.Data).SiteID;
              ATargetBoard.BoardID  :=  PNodeData(TreeView2.Selected.Data).BoardID;
              ATargetBoard.IsAll    :=  False;
            end;
          end;
        end;
      end;
      if  (PageControl1.ActivePageIndex = 0)  then  begin
        BuildNGWord;
        TreeView1.Selected  :=  TreeView1.Items[TreeView1.Items.Count - 1];
      end else begin
        TreeView2.OnChange(TreeView2, TreeView2.Selected);
      end;
    end;
  end;
end;

procedure TNGWordDialog.FormActivate(Sender: TObject);
begin
  SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
end;

procedure TNGWordDialog.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  SetWindowPos(Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
  NGWordList.SaveToFile(ZonuConfig.UsersPath + FILE_NG_WORD);
end;

procedure TNGWordDialog.Init;
begin
  Screen.Cursor :=  crHourglass;
  NGWordList.LoadFromFile(ZonuConfig.UsersPath + FILE_NG_WORD);
  BuildBoardList;
  BuildNGWord;
  Screen.Cursor :=  crDefault;
end;

end.
