{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 Send Window (Light) Unit                                          }
{                                                                             }
{ 2001-04 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit SendFormLight;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ExtCtrls, ActnList, Menus, ImgList,
  MenuBar, Buttons, ToolWin, ZonuClass, ZonuHttp, Hzbclass, Hzbconst;

type
  TSendDialogLight = class(TForm)
    StatusBar1: TStatusBar;
    Timer1: TTimer;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    SAGE1: TMenuItem;
    Send1: TMenuItem;
    Edit1: TMenuItem;
    SAGE2: TMenuItem;
    PRE1: TMenuItem;
    T1: TMenuItem;
    Show1: TMenuItem;
    Font1: TMenuItem;
    R1: TMenuItem;
    ActionList1: TActionList;
    actSend: TAction;
    actPre: TAction;
    actSage: TAction;
    actTouhaba: TAction;
    actShowAAList: TAction;
    actSelectAll: TAction;
    CoolBar1: TCoolBar;
    Panel3: TPanel;
    SpeedButton1: TSpeedButton;
    ToolBar2: TToolBar;
    ToolButton5: TToolButton;
    ToolButton13: TToolButton;
    ToolButton14: TToolButton;
    ToolButton7: TToolButton;
    CheckBox1: TCheckBox;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Panel2: TPanel;
    Label2: TLabel;
    Label1: TLabel;
    SenderMail: TComboBox;
    SenderName: TComboBox;
    SenderBody: TMemo;
    TabSheet2: TTabSheet;
    Memo2: TMemo;
    TabSheet4: TTabSheet;
    AAList: TListBox;
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDeactivate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure actSendExecute(Sender: TObject);
    procedure actSageExecute(Sender: TObject);
    procedure actPreExecute(Sender: TObject);
    procedure actTouhabaExecute(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure SenderBodyChange(Sender: TObject);
    procedure actShowAAListExecute(Sender: TObject);
    procedure AAListKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure AAListExit(Sender: TObject);
    procedure AAListDblClick(Sender: TObject);
    procedure actSelectAllExecute(Sender: TObject);
  private
    { Private 錾 }
    FSaveHeight : integer;
    FUrl: string;
    FCrypt: string;
    function GetPre: boolean;
    function GetSage: boolean;
    function GetTouhaba: boolean;
    procedure SaveSendSetting;
    procedure CreateParams(var Params: TCreateParams);
  protected
    FThreadItem: TThreadItem;
    FBoard: TBoard;
    FSite: TSite;
    FZonuHttp : TZonuHttp;
    FSendEvt: TNotifyEvent;
    FSending: boolean;
  public
    { Public 錾 }
    procedure SetThread(AThreadItem: TThreadItem);
    property  ThreadItem : TThreadItem  read  FThreadItem write FThreadItem;
    property  OnSend: TNotifyEvent  read  FSendEvt  write FSendEvt;
    property  Sending: boolean  read  FSending  write FSending;
    property  Url: string read  FUrl  write FUrl;
    property  Crypt: string read  FCrypt  write FCrypt;
    property  Sage: boolean read  GetSage;
    property  Pre: boolean  read  GetPre;
    property  Touhaba: boolean  read  GetTouhaba;
  end;

var
  SendDialogLight: TSendDialogLight;

implementation

{$R *.dfm}

uses
  ZonuConf, DolibModule, Main, MonaUtils, Hzbfunc, Zonutils;

procedure TSendDialogLight.FormCreate(Sender: TObject);
begin
  PageControl1.ActivePage :=  TabSheet1;
  SenderBody.Font.Name    :=  ZonuConfig.SendWindowFontName;
  SenderBody.Font.Size    :=  ZonuConfig.SendWindowFontSize;
  FSaveHeight             :=  Height;
  FSending                :=  False;
  CheckBox1.Checked       :=  ZonuConfig.SaveHandle;
  if  (FileExists(ZonuConfig.UsersPath + FILE_AA_LIST))  then  begin
    AAList.Items.LoadFromFile(ZonuConfig.UsersPath + FILE_AA_LIST);
  end;
end;

procedure TSendDialogLight.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  SetWindowPos(Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
  if  (Showing) and (Length(Trim(SenderBody.Text)) > 0)  then  begin
    CanClose  :=  (MessageDlg('ҏWłBĂ悩łH', mtWarning, [mbYes, mbNo],0) = mrYes);
  end;
  SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
end;

procedure TSendDialogLight.FormActivate(Sender: TObject);
var
  s : string;
begin
  SetActionEnabled(False);
  if  (ZonuConfig.SendWindowExpand) then  begin
    SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
  end;
  Height  :=  FSaveHeight;
  SetForegroundWindow(Self.Handle);
  if  (SenderBody.CanFocus) then  begin
    SenderBody.SetFocus;
    SenderBody.SelStart :=  Length(SenderBody.Lines.Text);
  end;
end;

procedure TSendDialogLight.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  SetActionEnabled(True);
  Action  := caFree;
end;

procedure TSendDialogLight.FormDeactivate(Sender: TObject);
begin
  SetActionEnabled(True);
end;

procedure TSendDialogLight.FormShow(Sender: TObject);
var
  s: string;
begin
  SetBounds(
    ZonuConfig.SendWindowPosLeft,
    ZonuConfig.SendWindowPosTop,
    ZonuConfig.SendWindowWidth,
    ZonuConfig.SendWindowHeight);
  FSaveHeight :=  Height;
  //LoadToolBarSetting;
end;

procedure TSendDialogLight.FormHide(Sender: TObject);
begin
  //SaveToolBarSetting;
  ZonuConfig.SendWindowPosTop   :=  Top;
  ZonuConfig.SendWindowPosLeft  :=  Left;
  ZonuConfig.SendWindowWidth    :=  Width;
  ZonuConfig.SendWindowHeight   :=  Height;
end;

procedure TSendDialogLight.FormDestroy(Sender: TObject);
begin
  PageControl1.ActivePageIndex  :=  0;
  SetWindowPos(Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
  SetActionEnabled(True);
  if  (FThreadItem <> nil)  then  begin
    FThreadItem.ReleaseRef;
  end;
end;

procedure TSendDialogLight.SetThread(AThreadItem: TThreadItem);
  procedure Reset(ComboBox: TComboBox; const S: string);
  begin
    if  (S <> '') then  begin
      if  (ComboBox.Items.IndexOf(S) < 0) then  begin
        ComboBox.Items.Insert(0, S);
      end else begin
        ComboBox.Items.Move(ComboBox.Items.IndexOf(S), 0);
      end;
    end;
  end;
var
  ASenderName, ASenderMail : string;
  List : TStringList;
  S : string;
  i : integer;
begin
  FThreadItem :=  AThreadItem;

  FThreadItem.AddRef;
  FBoard      :=  FThreadItem.Board;
  Caption     :=  AThreadItem.Title + ' ɏ';
  //GetLocalRule;
  actSage.Enabled     :=    (soSage     in  FThreadItem.BBS.SendOption);
  actPre.Enabled      :=    (soPre      in  FThreadItem.BBS.SendOption);
  actTouhaba.Enabled  :=    (soTouhaba  in  FThreadItem.BBS.SendOption);
  //
  if  (FileExists(ZonuConfig.UsersPath + FILE_NAME_LOG)) then  begin
    SenderName.Items.LoadFromFile(ZonuConfig.UsersPath + FILE_NAME_LOG);
  end;
  if  (FileExists(ZonuConfig.UsersPath + FILE_MAIL_LOG)) then  begin
    SenderMail.Items.LoadFromFile(ZonuConfig.UsersPath + FILE_MAIL_LOG);
  end;
  ASenderName :=  '';
  ASenderMail :=  '';
  //O[onh
  if  (ZonuConfig.GlobalHandle <> '') then  begin
    ASenderName :=  ZonuConfig.GlobalHandle;
    Reset(SenderName, ASenderName);
  end;
  if  (ZonuConfig.GlobalMail <> '') then  begin
    ASenderMail :=  ZonuConfig.GlobalMail;
    Reset(SenderMail, ASenderMail);
  end;
  //ʃnh
  List  :=  TStringList.Create;
  if  (FileExists(ZonuConfig.UsersPath + FILE_HANDLE_SETTING))  then  begin
    List.LoadFromFile(ZonuConfig.UsersPath + FILE_HANDLE_SETTING);
  end;
  S :=  List.Values[AThreadItem.Site.SiteID + '_' + AThreadItem.BoardID + '_HANDLE'];
  if  (S <> '') then  begin
    ASenderName :=  S;
    Reset(SenderName, ASenderName);
  end;
  S :=  List.Values[AThreadItem.Site.SiteID + '_' + AThreadItem.BoardID + '_MAIL'];
  if  (S <> '') then  begin
    ASenderMail :=  S;
    Reset(SenderMail, ASenderMail);
  end;
  List.Clear;
  //Xbh
  if  (FileExists(ZonuConfig.UsersPath + FILE_THREAD_HANDLE))  then  begin
    List.LoadFromFile(ZonuConfig.UsersPath + FILE_THREAD_HANDLE);
    for i :=  0 to  List.Count - 1  do  begin
      S :=  ChooseString(List[i], #9, 0);
      if  (AnsiPos(S, AThreadItem.Title) >0)  then  begin
        ASenderName :=  ChooseString(List[i], #9, 1);
        Reset(SenderName, ASenderName);
        ASenderMail :=  ChooseString(List[i], #9, 2);
        Reset(SenderMail, ASenderMail);
      end;
    end;
  end;
  List.Clear;
  //ߋ̎gpnh
  if  (FileExists(ZonuConfig.UsersPath + FILE_SEND_NAME))  then  begin
    List.LoadFromFile(ZonuConfig.UsersPath + FILE_SEND_NAME);
    for i :=  0 to  List.Count - 1  do  begin
      S :=  ChooseString(List[i], #9, 0);
      if  (AThreadItem.Site.SiteID + '_' +
           AThreadItem.BoardID + '_' +
           AThreadItem.DatNo = S) then
      begin
        ASenderName :=  ChooseString(List[i], #9, 1);
        Reset(SenderName, ASenderName);
        ASenderMail :=  ChooseString(List[i], #9, 2);
        Reset(SenderMail, ASenderMail);
        actSage.Checked     :=    (ChooseString(List[i], #9, 3) = '1');
        actPre.Checked      :=    (ChooseString(List[i], #9, 4) = '1');
        actTouhaba.Checked  :=    (ChooseString(List[i], #9, 5) = '1');
      end;
    end;
  end;
  List.Free;
  SenderName.Text :=  ASenderName;
  SenderMail.Text :=  ASenderMail;
  //݃O
  if  (FileExists(ZonuConfig.UsersPath + FILE_SEND_LOG))  then  begin
    try
      Memo2.Lines.LoadFromFile(ZonuConfig.UsersPath + FILE_SEND_LOG);
    except
      SetWindowPos(Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
      MessageDlg('݃O̗eʂz܂B' + #13#10 +
                 '܂ł̏݃Oʖŕۑ܂B' + #13#10 +
                 ' ' + #13#10 +
                  ChangeFileExt(ZonuConfig.UsersPath + FILE_SEND_LOG, '.bak'),
                  mtWarning, [mbOk] ,0);
      if  (FileExists(ChangeFileExt(ZonuConfig.UsersPath + FILE_SEND_LOG, '.bak')))  then  begin
        DeleteFileEx(ChangeFileExt(ZonuConfig.UsersPath + FILE_SEND_LOG, '.bak'));
      end;
      RenameFile(ZonuConfig.UsersPath + FILE_SEND_LOG,
                 ChangeFileExt(ZonuConfig.UsersPath + FILE_SEND_LOG, '.bak'));
      SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
    end;
  end;
end;

procedure TSendDialogLight.actSendExecute(Sender: TObject);
begin
  SaveSendSetting;

  if  (AnsiLowerCase(FBoard.Site.SiteID) = '2ch') and
      (AnsiPos('', SenderName.Text) > 0)  and
      (ZonuConfig.DolibUserName <> '')  and
      (not DolibManager.Connected)  then
  begin
    SetWindowPos(Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
    if  (MessageDlg('Q˂փOC܂H', mtInformation, [mbYes, mbNo] ,0) = mrYes) then
    begin
      if  (not DolibManager.Connect)  then  begin
        DolibManager.Disconnect;
        SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
        Exit;
      end;
    end;
  end;

  if  (ZonuConfig.FusianasanWarning)  then  begin
    if  (AnsiPos('fusianasan', SenderName.Text) > 0)  then  begin
      if  (MessageDlg('fusianasanŏƂĂ܂B' + #13#10 +
                      'fɂĂfusianasanŏނƃ[gzXg\ꂽ肵܂B' + #13#10 +
                      '݂܂H',
           mtWarning, [mbYes, mbNo] ,0) = mrNo) then
      begin
        Exit;
      end;
    end;
  end;
  if  (ZonuConfig.MachiBBSWarning)  and (ThreadItem.BBS.BBSID = BBS_MACHIBBS)  then  begin
    if  (MessageDlg('܂BBSɏƂĂ܂B' + #13#10 +
                    '܂BBS̓[gzXg̎EJ܂B' + #13#10 +
                    '݂܂H',
         mtWarning, [mbYes, mbNo] ,0) = mrNo) then
    begin
      Exit;
    end;
  end;

  SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);

  FSending  :=  True;
  Hide;
  if  (Assigned(FSendEvt))  then  begin
    FSendEvt(Self);
  end;
end;

procedure TSendDialogLight.SaveSendSetting;
  function BoolToStr(const b: boolean): string;
  begin
    if  (b) then  Result  :=  '1' else  Result  :=  '0';
  end;
var
  FSenderName, FSenderMail : string;
  List : TStringList;
begin
  List  :=  TStringList.Create;

  FSenderName   :=  SenderName.Text;
  FSenderMail   :=  SenderMail.Text;

  //
  //  Me̕ۑ
  //
  if  (ZonuConfig.SaveHist) then  begin
    if  (FileExists(ZonuConfig.UsersPath + FILE_SEND_LOG))  then  begin
      List.LoadFromFile(ZonuConfig.UsersPath + FILE_SEND_LOG);
    end else begin
      List.Clear;
    end;
    List.Insert(0, '---------- ');
    List.Insert(0, ' ');
    List.Insert(0, SenderBody.Text);
    List.Insert(0, ' ');
    List.Insert(0, '{@F ');
    List.Insert(0, 'eF' + DateTimeToStr(Now));
    List.Insert(0, '[F' + SenderMail.Text);
    List.Insert(0, 'eҁF' + SenderName.Text);
    List.Insert(0, '@F' + FThreadItem.Board.Name + '' + FThreadItem.Site.SiteName);
    List.Insert(0, 'XF' + FThreadItem.Title);
    List.Insert(0, ' ');
    {
    List.Insert(0, '--');
    List.Insert(0, SenderBody.Text);
    List.Insert(0,
                FThreadItem.Title + '^' +
                FThreadItem.Board.Name + '' +
                FThreadItem.Site.SiteName +
                ' eҁF' + SenderName.Text + ' [F' + SenderMail.Text +
                ' eF' + DateTimeToStr(Now)
                );
    }
    List.SaveToFile(ZonuConfig.UsersPath + FILE_SEND_LOG);

    //
    //  nh̕ۑ
    //
    if  (CheckBox1.Checked) then  begin
      if  (FileExists(ZonuConfig.UsersPath + FILE_SEND_NAME))  then  begin
        List.LoadFromFile(ZonuConfig.UsersPath + FILE_SEND_NAME);
      end else begin
        List.Clear;
      end;
      List.Add(FThreadItem.Site.SiteID + '_' +
               FThreadItem.BoardID + '_' +
               FThreadItem.DatNo + #9 +
               SenderName.Text + #9 +
               SenderMail.Text + #9 +
               BoolToStr(actSage.Checked) + #9 +
               BoolToStr(actPre.Checked) + #9 +
               BoolToStr(actTouhaba.Checked));
      while (List.Count > 1024) do  begin
        List.Delete(0);
      end;
      List.SaveToFile(ZonuConfig.UsersPath + FILE_SEND_NAME);
    end;
    if  (SenderName.Text <> '') then  begin
      if  (SenderName.Items.IndexOf(SenderName.Text) < 0) then  begin
        SenderName.Items.Insert(0, SenderName.Text);
      end else begin
        SenderName.Items.Move(SenderName.Items.IndexOf(SenderName.Text), 0);
      end;
      SenderName.Items.SaveToFile(ZonuConfig.UsersPath + FILE_NAME_LOG);
    end;
    if  (SenderMail.Text <> '') then  begin
      if  (SenderMail.Items.IndexOf(SenderMail.Text) < 0) then  begin
        SenderMail.Items.Insert(0, SenderMail.Text);
      end else begin
        SenderMail.Items.Move(SenderMail.Items.IndexOf(SenderMail.Text), 0);
      end;
      SenderMail.Items.SaveToFile(ZonuConfig.UsersPath + FILE_MAIL_LOG);
    end;
    ZonuConfig.SaveHandle :=  CheckBox1.Checked;
  end;
  
  SenderName.Text   :=  FSenderName;
  SenderMail.Text   :=  FSenderMail;

  List.Free;
end;

function TSendDialogLight.GetPre: boolean;
begin
  Result  :=  (actPre.Checked and actPre.Enabled);
end;

function TSendDialogLight.GetSage: boolean;
begin
  Result  :=  (actSage.Checked and actSage.Enabled);
end;

function TSendDialogLight.GetTouhaba: boolean;
begin
  Result  :=  (actTouhaba.Checked and actTouhaba.Enabled);
end;

procedure TSendDialogLight.actSageExecute(Sender: TObject);
begin
  actSage.Checked :=  not actSage.Checked;
  if  (soSageMail in FBoard.BBS.SendOption) then  begin
    try
      if  (actSage.Checked) then  begin
        if  (AnsiPos('sage', SenderMail.Text) = 0)  then  begin
          SenderMail.Text :=  'sage' + SenderMail.Text;
        end;
      end else begin
        if  (AnsiPos('sage', SenderMail.Text) = 1)  then  begin
          SenderMail.Text :=  Copy(SenderMail.Text, 5, Length(SenderMail.Text));
        end;
      end;
    except
      SenderMail.Text :=  'sage';
    end;
  end;
end;

procedure TSendDialogLight.actPreExecute(Sender: TObject);
begin
  actPre.Checked  :=  not actPre.Checked;
end;

procedure TSendDialogLight.actTouhabaExecute(Sender: TObject);
begin
  actTouhaba.Checked  :=  not actTouhaba.Checked;
end;

procedure TSendDialogLight.PageControl1Change(Sender: TObject);
begin
  SpeedButton1.Enabled  :=  (PageControl1.ActivePage = TabSheet1);
  actSage.Enabled       :=  (PageControl1.ActivePage = TabSheet1);
  actPre.Enabled        :=  (PageControl1.ActivePage = TabSheet1);
  actTouhaba.Enabled    :=  (PageControl1.ActivePage = TabSheet1);
end;

procedure TSendDialogLight.SenderBodyChange(Sender: TObject);
begin
  Timer1.Enabled  :=  False;
  Timer1.Enabled  :=  True;
  StatusBar1.Panels[0].Text :=  Format('s: %d  : %d', [SenderBody.Lines.Count, Length(SenderBody.Lines.Text)]); 
end;

procedure TSendDialogLight.actShowAAListExecute(Sender: TObject);
var
  p : TPoint;
begin
  GetCaretPos(p);
  AAList.Top    :=  {SenderBody.ClientOrigin.Y + }PageControl1.Top + TabSheet1.Top  + SenderBody.Top  + p.Y + Abs(SenderBody.Font.Height);
  AAList.Left   :=  {SenderBody.ClientOrigin.X + }PageControl1.Left+ TabSheet1.Left + SenderBody.Left + p.X;
  AAList.ItemIndex  :=  0;
  AAList.Show;
  AAList.SetFocus;
end;

procedure TSendDialogLight.AAListKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if  (Key  = VK_ESCAPE)  then  begin
    AAList.Hide;
    SenderBody.SetFocus;
  end else
  if  (Key  = VK_RETURN)  then  begin
    if  (AAList.ItemIndex > -1) then  begin
      SenderBody.SelText  :=  AAList.Items[AAList.ItemIndex];
    end;
    AAList.Hide;
    SenderBody.SetFocus;
  end;
end;

procedure TSendDialogLight.AAListExit(Sender: TObject);
begin
  AAList.Hide;
end;

procedure TSendDialogLight.AAListDblClick(Sender: TObject);
begin
  if  (AAList.ItemIndex > -1) then  begin
    SenderBody.SelText  :=  AAList.Items[AAList.ItemIndex];
  end;
  AAList.Hide;
  SenderBody.SetFocus;
end;

procedure TSendDialogLight.actSelectAllExecute(Sender: TObject);
begin
  SenderBody.SelectAll;
end;

procedure TSendDialogLight.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  Params.ExStyle := Params.ExStyle or WS_EX_APPWINDOW;
end;

end.
