{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 Shitaraba Messager Unit                                           }
{                                                                             }
{ 2001-04 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit ShitarabaMsg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ToolWin, ExtCtrls, ZonuSplitter, EnhListView,
  ExtListView, StdCtrls, ActnList, HttpProt, OleCtrls, SHDocVw, EmbeddedWB,
  MSHTML, Main, Menus, ImgList;

type
  TShitarabaMailBox = class;
  TShitarabaMessage = class;

  TShitarabaMessagerDialog = class(TForm)
    StatusBar1: TStatusBar;
    CoolBar1: TCoolBar;
    Panel1: TPanel;
    Panel2: TPanel;
    ListView1: TdfsExtListView;
    ZonuSplitter1: TZonuSplitter;
    Panel3: TPanel;
    Panel4: TPanel;
    Shape1: TShape;
    Label1: TLabel;
    Label2: TLabel;
    ToolBar1: TToolBar;
    ActionList1: TActionList;
    HttpCli1: THttpCli;
    actLogin: TAction;
    ToolButton1: TToolButton;
    WebBrowser1: TEmbeddedWB;
    Panel5: TPanel;
    Label3: TLabel;
    Label4: TLabel;
    SenderName: TLabel;
    DateTime: TLabel;
    actDelete: TAction;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    PopupMenu1: TPopupMenu;
    Delete1: TMenuItem;
    actReply: TAction;
    ImageList1: TImageList;
    R1: TMenuItem;
    N1: TMenuItem;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    procedure actLoginExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ListView1Change(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure actDeleteExecute(Sender: TObject);
    procedure actReplyExecute(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
  private
    { Private 錾 }
    FMail: TStringList;
    FMailBox:  TShitarabaMailBox;
    FPassword: string;
    procedure ParseShitarabaMessage;
    procedure Build;
    function GetActiveMsg(var Msg: TShitarabaMessage): boolean;
    procedure DeleteMsg(const MsgNo: string);
    procedure Open;
  public
    { Public 錾 }
  end;

  TShitarabaMessage = class(TObject)
  private
    FSenderName: string;
    FDateTime: string;
    FBody: string;
    FMailNo: string;
    FCanReply: boolean;
    FIsNew: boolean;
    FID: string;
  public
    property  ID: string  read  FID  write FID;
    property  SenderName: string    read  FSenderName write FSenderName;
    property  DateTime: string  read  FDateTime write FDateTime;
    property  MailBody: string  read  FBody write FBody;
    property  MailNo: string  read  FMailNo write FMailNo;
    property  CanReply: boolean read  FCanReply write FCanReply;
    property  IsNew: boolean  read  FIsNew  write FIsNew;
  end;

  TShitarabaMailBox = class(TList)
  private
    function GetItem(index: integer): TShitarabaMessage;
    procedure SetItem(index: integer; const Value: TShitarabaMessage);
  public
    destructor Destroy; override;
    function  Add(Value: TShitarabaMessage): integer;
    procedure Delete(Index: integer);
    procedure Clear; override;
    property  Items[index: integer]: TShitarabaMessage read GetItem write SetItem; default;
  end;

var
  ShitarabaMessagerDialog: TShitarabaMessagerDialog;

implementation

{$R *.dfm}

uses
  jconvert, ZonuConf, Hzbconst, ShitarabaMail, ShitarabaLogin;

{ TShitarabaMailBox }

destructor TShitarabaMailBox.Destroy;
begin
  Clear;
  inherited;
end;

function TShitarabaMailBox.Add(Value: TShitarabaMessage): integer;
begin
  Result  :=  inherited Add(Value);
end;

procedure TShitarabaMailBox.Clear;
var
  i : integer;
begin
  for i :=  Count - 1 downto  0 do  begin
    Delete(i);
  end;
  inherited;
end;

procedure TShitarabaMailBox.Delete(Index: integer);
begin
  TShitarabaMessage(Items[Index]).Free;
  inherited Delete(Index);
end;

function TShitarabaMailBox.GetItem(index: integer): TShitarabaMessage;
begin
  Result  :=  TShitarabaMessage(inherited Items[index]);
end;

procedure TShitarabaMailBox.SetItem(index: integer;
  const Value: TShitarabaMessage);
begin
  inherited Items[index]  :=  Value;
end;

{ TShitarabaMessagerDialog }

procedure TShitarabaMessagerDialog.FormCreate(Sender: TObject);
begin
  FMail     :=  TStringList.Create;
  FMailBox  :=  TShitarabaMailBox.Create;
  actLogin.Execute;
end;

procedure TShitarabaMessagerDialog.FormDestroy(Sender: TObject);
begin
  FMail.Free;
  FMailBox.Free;
end;

procedure TShitarabaMessagerDialog.actLoginExecute(Sender: TObject);
begin
  ShitaragaLoginDialog := TShitaragaLoginDialog.Create(Self);
  if  (ShitaragaLoginDialog.ShowModal = mrOk) then  begin
    FPassword :=  ShitaragaLoginDialog.Password;
    Open;
  end;
  ShitaragaLoginDialog.Release;
end;

procedure TShitarabaMessagerDialog.Open;
var
  FHttpStream : TStringStream;
  FPostStream : TStringStream;
  s : string;
begin
  Screen.Cursor :=  crHourGlass;
  FHttpStream  :=  TStringStream.Create('');
  FPostStream  :=  TStringStream.Create('password=' + FPassword + '&type=disp&submit=OC');
  if  (ZonuConfig.ProxyUse) then  begin
    HttpCli1.Proxy          :=  ZonuConfig.Proxy;
    HttpCli1.ProxyPort      :=  ZonuConfig.ProxyPort;
    HttpCli1.ProxyUsername  :=  ZonuConfig.ProxyUserName;
    HttpCli1.ProxyPassword  :=  ZonuConfig.ProxyPassword;
  end;
  HttpCli1.Agent            :=  USER_AGENT;
  FHttpStream.Position      :=  0;
  FHttpStream.Size          :=  0;
  HttpCli1.SendStream       :=  FPostStream;
  HttpCli1.RcvdStream       :=  FHttpStream;
  HttpCli1.URL              :=  ZonuConfig.ShitarabaMsgUrl;
  HttpCli1.Reference        :=  'Referer: http://www.shitaraba.com/message.html';
  HttpCli1.Post;
  s :=  jconvert.euc2sjis(FHttpStream.DataString);
  s :=  StringReplace(s, #10, #13#10, [rfReplaceAll]);
  FMail.Clear;
  FMail.Text  :=  s;
  ParseShitarabaMessage;
  Build;
  FHttpStream.Free;
  FPostStream.Free;
  Screen.Cursor :=  crDefault;
end;

procedure TShitarabaMessagerDialog.ParseShitarabaMessage;
var
  Msg : TShitarabaMessage;
  i : integer;
  s : string;
begin
  FMailBox.Clear;
  Msg :=  nil;
  for i :=  0 to  FMail.Count - 1 do  begin
    if  (AnsiPos('<td width="20%">', FMail[i]) > 0) and
        (AnsiPos('</td>', FMail[i]) > 0) then
    begin
      Msg :=  TShitarabaMessage.Create;
      FMailBox.Add(Msg);
      //<td width="20%">Dax<br>2002/02/06() 23:20</td>
      s     :=  Copy(FMail[i], AnsiPos('>', FMail[i]) + 1, Length(FMail[i]));
      Msg.SenderName  :=  Copy(s, 1, AnsiPos('<', s) - 1);
      //Dax<br>2002/02/06() 23:20</td>
      s     :=  Copy(s, AnsiPos('>', s) + 1, Length(s));
      //2002/02/06() 23:20</td>
      Msg.DateTime    :=  Copy(s, 1, AnsiPos('<', s) - 1);

      s     :=  Copy(FMail[i], AnsiPos('<td width="60%">', FMail[i]) + 16, Length(FMail[i]));
      Msg.MailBody  :=  Copy(s, 1, AnsiPos('</a></td>', s) - 1);
      Msg.CanReply  :=  False;
      Msg.ID        :=  '';
      Msg.IsNew     :=  (AnsiPos('font color=red></font>', FMail[i]) > 0);
    {
    end else
    if  (AnsiPos('<td width="60%">', FMail[i]) > 0) and
        (AnsiPos('</td>', FMail[i]) > 0) then
    begin
      //<td width="60%">eXg<BR>Ă<BR>ĂƓełB</a></td>
      s     :=  Copy(FMail[i], AnsiPos('>', FMail[i]) + 1, Length(FMail[i]));
      Msg.MailBody  :=  Copy(s, 1, AnsiPos('</a></td>', s) - 1);
    }
    end else
    if  (AnsiPos('<a href=./message.cgi', FMail[i]) > 0) and
        (AnsiPos('ԐM</a>', FMail[i]) > 0) then
    begin
      Msg.CanReply  :=  True;
      s :=  Copy(FMail[i], AnsiPos('&id=', FMail[i]) + 4, Length(FMail[i]));
      Msg.ID  :=  Copy(s, 1, AnsiPos('>', s) - 1);
    end else
    if  (AnsiPos('<input type=checkbox', FMail[i]) > 0) then  begin
      //        <input type="hidden" name = "no" value="1013005219">
      //        <input type=checkbox name = "1015249876" value="true"></center>
      s     :=  Copy(FMail[i], AnsiPos('name = "', FMail[i]) + 8, Length(FMail[i]));
      Msg.MailNo  :=  Copy(s, 1, AnsiPos('"', s) - 1);
    end;
  end;
end;

function TShitarabaMessagerDialog.GetActiveMsg(var Msg: TShitarabaMessage): boolean;
begin
  Result  :=  False;
  if  (ListView1.Selected <> nil) then  begin
    if  (ListView1.Selected.Data <> nil) then  begin
      Msg     :=  TShitarabaMessage(ListView1.Selected.Data);
      Result  :=  True;
    end;
  end;
end;

procedure TShitarabaMessagerDialog.Build;
var
  Item  : TListItem;
  i : integer;
begin
  ListView1.Items.Clear;
  ListView1.AutoResort  :=  False;
  for i :=  0 to  FMailBox.Count - 1  do  begin
    Item  :=  ListView1.Items.Add;
    Item.Caption  :=  Format('%.3d', [i + 1]);
    Item.SubItems.Add(FMailBox[i].SenderName);
    Item.SubItems.Add(FMailBox[i].DateTime);
    if  (FMailBox[i].IsNew) then  begin
      Item.ImageIndex :=  0;
    end else begin
      Item.ImageIndex :=  1;
    end;
    Item.Data :=  FMailBox[i];
  end;
  WebBrowser1.Navigate('about:blank');
  ListView1.AutoResort  :=  True;
  //ListView1.Resort;
end;

{
Memo1
<html>
<head>
<title>Dax  Shitaraba Messager</title>
<meta http-equiv="Content-Type" content="text/html; charset=x-euc-jp">
</head>
<body bgcolor="#FFFFFF" text="#336666" link="#009999" alink="#00FFFF" vlink="#66CCCC">
<font size="4"><b>Dax  Shitaraba Messager</b></font>
<hr>
 2 ̃bZ[W܂
<table width="100%" border="1" cellspacing="0" cellpadding="0">
  <tr>
    <td width="20%">
      <div align="center">ol</div>
    </td>
    <td width="60%">
      <div align="center">bZ[W</div>
    </td>
    <td width="10%">
      <div align="center">폜</div>
    </td>
    <td width="10%">
      <div align="center">ԐM</div>
    </td>
  </tr>
  <tr>
    <td width="20%">Dax<br>2002/02/06() 23:20</td>
    <td width="60%">eXg<BR>Ă<BR>ĂƓełB</a></td>
    <td width="10%">
      <form method=post action="./message.cgi">
        <input type="hidden" name = "password" value=hogehoge>
        <input type="hidden" name = "type" value="delete">
        <input type="hidden" name = "no" value="1013005219">
        <input type="submit" name="submit2" value="폜">
      </form>
    </td>
    <td width="10%">
      <form method=post action="./message.cgi">
	<input type="hidden" name="sid" value=hogehoge>
	<input type="hidden" name="id" value=998141931>
	<input type="submit" name="submit" value="ԐM">
      </form>
    </td>
  </tr>
  <tr>
    <td width="20%">Ă<br>2002/02/06() 23:20</td>
    <td width="60%">http://www.monazilla.org/<BR>eXgełB<BR>ǂȂ̂ȁH</a></td>
    <td width="10%">
      <form method=post action="./message.cgi">
        <input type="hidden" name = "password" value=hogehoge>
        <input type="hidden" name = "type" value="delete">
        <input type="hidden" name = "no" value="1013005257">
        <input type="submit" name="submit2" value="폜">
      </form>
    </td>
    <td width="10%">
@    </td>
  </tr>
</table>
</body>
</html>

}
procedure TShitarabaMessagerDialog.ListView1Change(Sender: TObject;
  Item: TListItem; Change: TItemChange);
var
  doc : variant;
  Msg : TShitarabaMessage;
begin
  if  (GetActiveMsg(Msg)) then  begin
    IHTMLDocument2(WebBrowser1.Document).charset := 'shift_jis';
    Msg :=  TShitarabaMessage(ListView1.Selected.Data);
    if  (Msg.IsNew) then  begin
      ListView1.Selected.ImageIndex :=  1;
      Msg.IsNew :=  False;
    end;
    doc :=  WebBrowser1.Document;
    doc.Write('<html><body>');
    doc.Write('<font face="lr oSVbN">');
    doc.Write(Msg.MailBody);
    doc.Write('</font>');
    doc.Write('</body></html>');
    doc.Close;
    SenderName.Caption  :=  Msg.SenderName;
    DateTime.Caption    :=  Msg.DateTime;
  end;
end;

procedure TShitarabaMessagerDialog.actDeleteExecute(Sender: TObject);
var
  Msg : TShitarabaMessage;
begin
  if  (GetActiveMsg(Msg)) then  begin
    if  (MessageDlg('bZ[W폜܂H' + #13#10 +
                    Msg.SenderName + ' ' + Msg.DateTime,
                    mtWarning, [mbYes, mbNo], 0) = mrYes) then
    begin
      DeleteMsg(Msg.MailNo);
      Open;
    end;
  end;
end;

procedure TShitarabaMessagerDialog.DeleteMsg(const MsgNo: string);
var
  FHttpCli    : THttpCli;
  FPostStream : TStringStream;
  Msg: TShitarabaMessage;
  s: string;
  i: integer;
begin
  Screen.Cursor :=  crHourGlass;
  s :=  'password=' + FPassword + '&type=delete' + '&bbs=' +
        '&' + MsgNO + '=true' + '&submit=폜';

  s :=  jconvert.sjis2euc(s);

  FPostStream  :=  TStringStream.Create(s);

  FHttpCli                  :=  THttpCli.Create(nil);
  if  (ZonuConfig.ProxyUse) then  begin
    FHttpCli.Proxy          :=  ZonuConfig.Proxy;
    FHttpCli.ProxyPort      :=  ZonuConfig.ProxyPort;
    FHttpCli.ProxyUsername  :=  ZonuConfig.ProxyUserName;
    FHttpCli.ProxyPassword  :=  ZonuConfig.ProxyPassword;
  end;
  FHttpCli.Agent            :=  USER_AGENT;
  FHttpCli.SendStream       :=  FPostStream;
  FHttpCli.URL              :=  ZonuConfig.ShitarabaMsgUrl;
  FHttpCli.Reference        :=  'Referer: http://www.shitaraba.com/message.html';
  try
    try
      FHttpCli.Post;
    except
      //
    end;
  finally
    FHttpCli.Free;
    FPostStream.Free;
    if  (GetActiveMsg(Msg)) then  begin
      for i :=  FMailBox.Count - 1  downto  0 do  begin
        if  (FMailBox[i] = Msg) then  begin
          FMailBox.Delete(i);
        end;
      end;
    end;
    Build;
    Screen.Cursor :=  crDefault;
  end;
end;

procedure TShitarabaMessagerDialog.actReplyExecute(Sender: TObject);
var
  Msg : TShitarabaMessage;
begin
  if  (GetActiveMsg(Msg)) then  begin
    if  (Msg.CanReply)  then  begin
      ShitarabaMailDialog   :=  TShitarabaMailDialog.Create(Self);
      ShitarabaMailDialog.SendTo    :=  Msg.SenderName;
      ShitarabaMailDialog.ToID      :=  Msg.ID;
      ShitarabaMailDialog.SendFrom  :=  '#' + FPassword;
      ShitarabaMailDialog.Password  :=  FPassword;
      ShitarabaMailDialog.Body      :=  Msg.MailBody;
      ShitarabaMailDialog.Show;
    end else begin
      MessageDlg('̃bZ[WɕԐM͂ł܂B', mtError, [mbOk], 0);
    end;
  end;
end;

procedure TShitarabaMessagerDialog.FormActivate(Sender: TObject);
begin
  SetWindowPos(Handle,  HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
end;

procedure TShitarabaMessagerDialog.FormClose(Sender: TObject;
  var Action: TCloseAction);
var
  i: integer;
begin
  ZonuConfig.ShitarabaMsgWindowState :=  WindowState;
  if  (WindowState = wsNormal)  then  begin
    ZonuConfig.ShitarabaMsgWindowLeft   :=  Left;
    ZonuConfig.ShitarabaMsgWindowTop    :=  Top;
    ZonuConfig.ShitarabaMsgWindowWidth  :=  Width;
    ZonuConfig.ShitarabaMsgWindowHeight :=  Height;
  end;
  ZonuConfig.ShitarabaMsgPaneWidth   :=  Panel1.Width;
  for i :=  0 to  ListView1.Columns.Count - 1 do  begin
    ZonuConfig.ShitarabaMsgColumnWidth[i] :=  ListView1.Columns[i].Width;
  end;
  SetWindowPos(Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
end;

procedure TShitarabaMessagerDialog.FormShow(Sender: TObject);
var
  i: integer;
begin
  WindowState :=  ZonuConfig.ShitarabaMsgWindowState;
  if  (WindowState = wsNormal)  then  begin
    Self.SetBounds( ZonuConfig.ShitarabaMsgWindowLeft,
                    ZonuConfig.ShitarabaMsgWindowTop,
                    ZonuConfig.ShitarabaMsgWindowWidth,
                    ZonuConfig.ShitarabaMsgWindowHeight);
  end;
  Panel1.Width      :=  ZonuConfig.ShitarabaMsgPaneWidth;
  for i :=  0 to  ListView1.Columns.Count - 1 do  begin
    ListView1.Columns[i].Width  :=  ZonuConfig.ShitarabaMsgColumnWidth[i];
  end;
end;

end.
