{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 Skin Dialog Unit                                                  }
{                                                                             }
{ 2001-04 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Skindlg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, Dlghead, EnhListView, ExtListView, ExtCtrls, StdCtrls,
  Buttons, IniFiles, Menus;

type
  TSkinDialog = class(TForm)
    StatusBar1: TStatusBar;
    HeaderFrame1: THeaderFrame;
    Panel1: TPanel;
    Label1: TLabel;
    Edit1: TEdit;
    SpeedButton1: TSpeedButton;
    Bevel1: TBevel;
    PopupMenu1: TPopupMenu;
    E1: TMenuItem;
    N1: TMenuItem;
    D1: TMenuItem;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    ListView1: TdfsExtListView;
    Panel2: TPanel;
    Label2: TLabel;
    ComboBoxEx1: TComboBoxEx;
    ScrollBox1: TScrollBox;
    Label3: TLabel;
    Edit2: TEdit;
    SpeedButton2: TSpeedButton;
    Label4: TLabel;
    Edit3: TEdit;
    SpeedButton3: TSpeedButton;
    Label5: TLabel;
    Edit4: TEdit;
    SpeedButton4: TSpeedButton;
    Label6: TLabel;
    SpeedButton5: TSpeedButton;
    Edit5: TEdit;
    edtBBSSkin: TEdit;
    SpeedButton6: TSpeedButton;
    Label7: TLabel;
    Label8: TLabel;
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ComboBoxEx1Change(Sender: TObject);
    procedure ListView1DblClick(Sender: TObject);
    procedure D1Click(Sender: TObject);
    procedure Edit2KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure edtBBSSkinKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  SkinDialog: TSkinDialog;

implementation

{$R *.dfm}

uses
  ZonuClass, ZonuConf, Hzbconst, Skindlg2, MonaUtils, Hzbfunc;

procedure TSkinDialog.FormCreate(Sender: TObject);
var
  Item: TComboExItem;
  ini: TMemIniFile;
  i: integer;
begin
  PageControl1.ActivePage :=  TabSheet1;
  ComboBoxEx1.OnChange    :=  nil;
  ini :=  TMemIniFile.Create(ZonuConfig.UsersPath + INI_SKIN);
  Edit1.Text  :=  ExtractSkinName(ini.ReadString('default', 'SKINPATH', ''));
  Edit2.Text  :=  ExtractSkinName(ini.ReadString('siori_manager', 'SKINPATH', ''));
  Edit3.Text  :=  ExtractSkinName(ini.ReadString('linkextract_dialog', 'SKINPATH', ''));
  Edit4.Text  :=  ExtractSkinName(ini.ReadString('senddialog_preview', 'SKINPATH', ''));
  Edit5.Text  :=  ExtractSkinName(ini.ReadString('export_dialog', 'SKINPATH', ''));
  for i :=  0 to  ZonuEnviron.SiteList.Count - 1 do  begin
    if  (ZonuEnviron.SiteList[i].IsSubscription)  and
        (ZonuEnviron.SiteList[i].SiteType <> stFavorites) then
    begin
      Item  :=  ComboBoxEx1.ItemsEx.Add;
      Item.Caption    :=  ZonuEnviron.SiteList[i].SiteName;
      Item.Data       :=  ZonuEnviron.SiteList[i];
      Item.ImageIndex :=  ZonuEnviron.SiteList[i].ImageIndex;
    end;
  end;
  ini.Free;
  ComboBoxEx1.OnChange  :=  ComboBoxEx1Change;
  if  (ComboBoxEx1.Items.Count > 0) then  begin
    ComboBoxEx1.ItemIndex :=  0;
    ComboBoxEx1.OnChange(ComboBoxEx1);
  end;
end;

procedure TSkinDialog.FormDestroy(Sender: TObject);
begin
  //
end;

procedure TSkinDialog.SpeedButton1Click(Sender: TObject);
begin
  SkinDialog2     :=  TSkinDialog2.Create(Self);
  if  (Sender = SpeedButton1) then  begin
    SkinDialog2.Key :=  'default';
  end else
  if  (Sender = SpeedButton2) then  begin
    SkinDialog2.Key :=  'siori_manager';
  end else
  if  (Sender = SpeedButton3) then  begin
    SkinDialog2.Key :=  'linkextract_dialog';
  end else
  if  (Sender = SpeedButton4) then  begin
    SkinDialog2.Key :=  'senddialog_preview';
  end else
  if  (Sender = SpeedButton5) then  begin
    SkinDialog2.Key :=  'export_dialog';
  end else
  if  (Sender = SpeedButton6) then  begin
    SkinDialog2.Key :=  TSite(ComboBoxEx1.ItemsEx[ComboBoxEx1.ItemIndex].Data).SiteID;
  end;
  if  (SkinDialog2.ShowModal  = mrOk) then  begin
    if  (Sender = SpeedButton1) then  begin
      Edit1.Text  :=  ExtractSkinName(SkinDialog2.SkinPath);
    end else
    if  (Sender = SpeedButton2) then  begin
      Edit2.Text  :=  ExtractSkinName(SkinDialog2.SkinPath);
    end else
    if  (Sender = SpeedButton3) then  begin
      Edit3.Text  :=  ExtractSkinName(SkinDialog2.SkinPath);
    end else
    if  (Sender = SpeedButton4) then  begin
      Edit4.Text  :=  ExtractSkinName(SkinDialog2.SkinPath);
    end else
    if  (Sender = SpeedButton5) then  begin
      Edit5.Text  :=  ExtractSkinName(SkinDialog2.SkinPath);
    end else
    if  (Sender = SpeedButton6) then  begin
      edtBBSSkin.Text  :=  ExtractSkinName(SkinDialog2.SkinPath);
    end;
  end;
  SkinDialog2.Release;
end;

procedure TSkinDialog.ComboBoxEx1Change(Sender: TObject);
var
  Site: TSite;
  Board: TBoard;
  Item: TListItem;
  ini: TMemIniFile;
  i: integer;
begin
  ListView1.Items.BeginUpdate;
  ListView1.Items.Clear;
  ListView1.AutoResort  :=  False;
  Site  :=  TSite(ComboBoxEx1.ItemsEx[ComboBoxEx1.ItemIndex].Data);
  ini   :=  TMemIniFile.Create(ZonuConfig.UsersPath + INI_SKIN);
  for i :=  0 to  Site.BoardList.Count - 1  do  begin
    Board :=  Site.BoardList[i];
    Item  :=  ListView1.Items.Add;
    Item.Caption  :=  Site.SiteName;
    Item.SubItems.Add(Board.CategoryName);
    Item.SubItems.Add(Board.Name);
    if  (ini.SectionExists(Site.SiteID + '_' + Board.BoardID))  then  begin
      Item.SubItems.Add(ExtractSkinName(ini.ReadString(Site.SiteID + '_' + Board.BoardID, 'SKINPATH', '-')));
    end else begin
      Item.SubItems.Add('-')
    end;
    Item.Data :=  Board;
  end;
  ListView1.Items.EndUpdate;
  ListView1.AutoResort  :=  True;
  edtBBSSkin.Text       :=  '';
  if  (ini.SectionExists(Site.SiteID))  then  begin
    edtBBSSkin.Text     :=  ExtractSkinName(ini.ReadString(Site.SiteID, 'SKINPATH', '-'));
  end;
  ini.Free;
end;

procedure TSkinDialog.ListView1DblClick(Sender: TObject);
var
  Board: TBoard;
begin
  if  (ListView1.Selected <> nil) then  begin
    Board           :=  TBoard(ListView1.Selected.Data);
    SkinDialog2     :=  TSkinDialog2.Create(Self);
    SkinDialog2.Key :=  Board.Site.SiteID + '_' + Board.BoardID;
    if  (SkinDialog2.ShowModal  = mrOk) then  begin
      ListView1.Selected.SubItems.Delete(2);
      ListView1.Selected.SubItems.Add(ExtractSkinName(SkinDialog2.SkinPath));
    end;
    SkinDialog2.Release;
  end;
end;

procedure TSkinDialog.D1Click(Sender: TObject);
var
  Board: TBoard;
  ini: TMemIniFile;
begin
  if  (ListView1.Selected <> nil) then  begin
    Board           :=  TBoard(ListView1.Selected.Data);
    ListView1.Selected.SubItems.Delete(2);
    ListView1.Selected.SubItems.Add('-');
    ini   :=  TMemIniFile.Create(ZonuConfig.UsersPath + INI_SKIN);
    ini.EraseSection(Board.Site.SiteID + '_' + Board.BoardID);
    ini.UpdateFile;
    ini.Free;
  end;
end;

procedure TSkinDialog.Edit2KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  ini: TMemIniFile;
begin
  if  (Key = VK_DELETE) then  begin
    TEdit(Sender).Text  :=  '';
    ini   :=  TMemIniFile.Create(ZonuConfig.UsersPath + INI_SKIN);
    if  (Sender = Edit2)  then  begin
      ini.EraseSection('siori_manager');
    end else
    if  (Sender = Edit3)  then  begin
      ini.EraseSection('linkextract_dialog');
    end else
    if  (Sender = Edit4)  then  begin
      ini.EraseSection('senddialog_preview');
    end else
    if  (Sender = Edit5)  then  begin
      ini.EraseSection('export_dialog');
    end;
    ini.UpdateFile;
    ini.Free;
  end;
end;

procedure TSkinDialog.edtBBSSkinKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  ini: TMemIniFile;
begin
  if  (Key = VK_DELETE) then  begin
    edtBBSSkin.Text :=  '';
    ini   :=  TMemIniFile.Create(ZonuConfig.UsersPath + INI_SKIN);
    ini.EraseSection(TSite(ComboBoxEx1.ItemsEx[ComboBoxEx1.ItemIndex].Data).SiteID);
    ini.UpdateFile;
    ini.Free;
  end;
end;

end.
