{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 amezo-like BBS Script (amezor.to) Unit                            }
{                                                                             }
{ 2001-02 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit ZonuAmezor;

interface

uses
  Classes, SysUtils, HTTPApp, IniFiles, StrUtils,
  ZonuClass, ZonuCommon, ZonuHttp, Hzbconst;
  
type
  PParamData  = ^TParamData;
  TParamData  = record
    InHeadLine: boolean;
    ThreadItemCount : integer; //_E[hXbh̐
    ZonuHttp : TZonuHttp;
    Lines  : TStringList;
    DiffGet: boolean;  //擾ǂ
    NewCount: integer; //V擾XEMS-IMEAɔ恩ł܂Ԃł
  end;

  TAmezorScript = class(TBBS)
  private
    procedure _DownloadThreadList(Downloader: TThreadListDownloader;
      const NoCache, ASync, InfSave: boolean);
    { private }
  protected
    { protected }
    function GetThreadListType: TThreadListAccessType; override;
    function GetThreadDownloadMode: TThreadDownloadMode; override;
    function GetNeedHRefLink: boolean; override;
    function GetNeedLinkTarget: boolean; override;
    function GetRelativeLink: boolean; override;
    function GetIsPublished: boolean; override;
    procedure ZonuDataThreadList(Sender: TObject; Downloader: TDownloader;
      Data: string; TotalSize, DownloadSize: integer; var MoreData: boolean); override;
    procedure ZonuEndThreadList(Sender: TObject; Downloader: TDownloader;
      Error: boolean); override;
    procedure ZonuThreadListError(Sender: TObject; Downloader: TDownloader;
      ErrorCode: integer; ErrorMsg: string); override;
    procedure ZonuDataRes(Sender: TObject; Downloader: TDownloader;
      Data: string; TotalSize, DownloadSize: integer; var MoreData: boolean); override;
    procedure ZonuEndRes(Sender: TObject; Downloader: TDownloader;
      Error: boolean); override;
    procedure ZonuResError(Sender: TObject; Downloader: TDownloader;
      ErrorCode: integer; ErrorMsg: string); override;
  public
    { public }
    procedure ParseSubject(subject: string; out FileName: string;
      out Title: string; out Count: integer); override;
    procedure ParseDat(const ALine: string; const index: integer;
      var ARes: TRes; out ASubject: string); override;
    procedure DownloadThreadList(Downloader: TThreadListDownloader;
      const NoCache, ASync, InfSave: boolean); override;
    procedure DownloadThreadItem(Downloader: TResDownloader;
      const NoCache, ASync, InfSave, AutoPilot: boolean); override;
    procedure SendRes(Uploader: TResUploader); override;
    procedure SendThread(Uploader: TThreadUploader); override;
    function ConvUrl(const Url: string): string; override;
    function GetDisplayUrl(ThreadItem: TThreadItem): string; override;
    function ConvUrl2(const Url: string): string; 
  end;

implementation

uses
  MonaUtils;

{ TAmezorScript }

//
//  Xbhꗗ̎擾@
//
function TAmezorScript.GetThreadListType: TThreadListAccessType;
begin
  Result  :=  tlLump; // 1000Ă̂ňꊇ
end;

//
//  Xbh̎擾@
//
function TAmezorScript.GetThreadDownloadMode: TThreadDownloadMode;
begin
  Result  :=  dmText;
end;

//
//  http://ւ̃Nǉ
//
function TAmezorScript.GetNeedHRefLink: boolean;
begin
  Result  :=  True;
end;

//
//  NւTarget=_blankǉ
//
function TAmezorScript.GetNeedLinkTarget: boolean;
begin
  Result  :=  True;
end;

//
//  BBSEBU[hŕ\邩ǂ
//
function TAmezorScript.GetIsPublished: boolean;
begin
  Result  :=  True;
end;

//
//  Xbhꗗ_E[h
//
procedure TAmezorScript.DownloadThreadList(Downloader: TThreadListDownloader;
  const NoCache, ASync, InfSave: boolean);
var
  ParamData : PParamData;
begin
  New(ParamData);
  ParamData.Lines :=  TStringList.Create;
  ParamData.Lines.Clear;
  ParamData.ThreadItemCount :=  0;
  Downloader.ParamData      :=  ParamData;
  _DownloadThreadList(Downloader, NoCache, ASync, InfSave);
end;

procedure TAmezorScript._DownloadThreadList(Downloader: TThreadListDownloader;
  const NoCache, ASync, InfSave: boolean);
var
  FZonuHttp:  TZonuHttp;
  ParamData:  PParamData;
begin
  ParamData :=  PParamData(Downloader.ParamData);
  ParamData.InHeadLine :=  False;
  FZonuHttp                 :=  TZonuHttp.Create(nil);
  FZonuHttp.Downloader      :=  Downloader;
  FZonuHttp.OnZonuData      :=  ZonuDataThreadList;
  FZonuHttp.OnZonuEnd       :=  ZonuEndThreadList;
  FZonuHttp.OnZonuError     :=  ZonuThreadListError;
  FZonuHttp.Url             :=  GetSubjectUrl(Downloader.Board);
  FZonuHttp.NoCache         :=  NoCache;
  FZonuHttp.UserAgent       :=  USER_AGENT;
  FZonuHttp.InfSave         :=  InfSave;
  FZonuHttp.SendContent :=  'px=' + IntToStr(ParamData.ThreadItemCount + 1) +
                            '&tx=' + Downloader.Board.BoardID +
                            '&ssx=' + IntToStr(ParamData.ThreadItemCount + 1) +
                            '&go=' + HTTPApp.HTTPEncode('\');
  FZonuHttp.Reference   :=  'http://www.amezor.to/cgi-bin/res1000.cgi';
  FZonuHttp.GetAmezor(Downloader.Board.CachePath + 'subject.inf', ASync);
end;

//
//  Xbhꗗ擾
//
procedure TAmezorScript.ZonuDataThreadList(Sender: TObject;
  Downloader: TDownloader; Data: string; TotalSize,
  DownloadSize: integer; var MoreData: boolean);
var
  dl        : TThreadListDownloader;
  AFileName : string;
  ATitle    : string;
  ACount    : integer;
  ThreadItem: TThreadItem;
  ParamData : PParamData;
begin
  inherited;
  dl  :=  TThreadListDownloader(Downloader);
  if  (AnsiPos('<a href=', Data) > 0) then  begin
    ParseSubject(Data, AFileName, ATitle, ACount);
    ThreadItem                    :=  TThreadItem.Create;
    ThreadItem.BBS                :=  Self;
    ThreadItem.Site               :=  dl.Site;
    ThreadItem.BoardID            :=  dl.Board.BoardID;
    ThreadItem.No                 :=  0;
    ThreadItem.DatFileName        :=  AFileName;
    ThreadItem.Title              :=  ATitle;
    ThreadItem.AgeCount           :=  ACount;
    ThreadItem.RemoteDatFileName  :=  GetDatUrl(dl.Board, AFileName);
    ThreadItem.LocalDatFileName   :=  dl.Board.CachePath + AFileName;
    dl.FireDataEvt(ThreadItem, DownloadSize, TotalSize, MoreData);
  end;
end;

//
//  Xbhꗗ擾I
//
procedure TAmezorScript.ZonuEndThreadList(Sender: TObject;
  Downloader: TDownloader; Error: boolean);
var
  ParamData:  PParamData;
begin
  ParamData :=  PParamData(Downloader.ParamData);
  Dispose(ParamData);
  inherited;
end;

//
//  Xbhꗗ擾G[
//
procedure TAmezorScript.ZonuThreadListError(Sender: TObject;
  Downloader: TDownloader; ErrorCode: integer; ErrorMsg: string);
begin
  inherited;

end;

//
//  Xbhꗗ̉
//
procedure TAmezorScript.ParseSubject(subject: string; out FileName,
  Title: string; out Count: integer);
begin
  inherited;
  ParseAmezorSubject(subject, FileName, Title, Count);
end;

//
//  X̉
//
procedure TAmezorScript.ParseDat(const ALine: string; const index: integer;
  var ARes: TRes; out ASubject: string);
begin
  inherited;
  ParseAmezorDat(ALine, Index, ARes, ASubject);
end;

//
//  \URL
//
function TAmezorScript.GetDisplayUrl(ThreadItem: TThreadItem): string;
begin
  //Result  :=  GetReadCgiUrl(ThreadItem) + '&ls=50';
  Result  :=  ConvUrl2(GetReadCgiUrl(ThreadItem));
end;

//
//  Xbh̃_E[h
//
procedure TAmezorScript.DownloadThreadItem(Downloader: TResDownloader;
  const NoCache, ASync, InfSave, AutoPilot: boolean);
var
  ParamData : PParamData;
  FZonuHttp : TZonuHttp;
  Log     : TMemIniFile;
  inf     : string;
  size    : integer;
begin
  New(ParamData);
  ParamData.NewCount        :=  0;
  Downloader.ParamData      :=  ParamData;
  FZonuHttp                 :=  TZonuHttp.Create(nil);
  FZonuHttp.Downloader      :=  Downloader;
  FZonuHttp.OnZonuData      :=  ZonuDataRes;
  FZonuHttp.OnZonuEnd       :=  ZonuEndRes;
  FZonuHttp.OnZonuError     :=  ZonuResError;
  FZonuHttp.Url             :=  Downloader.ThreadItem.RemoteDatFileName;
  FZonuHttp.NoCache         :=  NoCache;
  FZonuHttp.UserAgent       :=  USER_AGENT;
  FZonuHttp.NeedDataEvent   :=  True;
  FZonuHttp.CacheReady      :=  False;
  FZonuHttp.InfSave         :=  InfSave;
  FZonuHttp.CacheReady      :=  Downloader.CacheReady;
  Downloader.HttpObj        :=  FZonuHttp;
  //
  ParamData.DiffGet  :=  False;
  inf :=  ChangeFileExt(Downloader.ThreadItem.LocalDatFileName, '.inf');
  if  (FileExists(inf)) then  begin
    Log   :=  TMemIniFile.Create(inf);
    size  :=  Log.ReadInteger('LOG', 'SIZE', 0);
    if  (size > 0)  then  begin
      FZonuHttp.ContentRangeBegin :=
          IntToStr(size - GetContentLength(Log.ReadString('AMEZOR', 'Footer','')) - 2);
      ParamData.DiffGet  :=  True;
      FZonuHttp.DiffText  :=  True;
    end;
    Log.Free;
  end;
  //
  FZonuHttp.DiffText  :=  ParamData.DiffGet;
  FZonuHttp.GetModified(ChangeFileExt(Downloader.ThreadItem.LocalDatFileName, '.inf'), ASync);
end;

//
//  X擾
//
procedure TAmezorScript.ZonuDataRes(Sender: TObject; Downloader: TDownloader;
  Data: string; TotalSize, DownloadSize: integer; var MoreData: boolean);
var
  dl  : TResDownloader;
  ASubject : string;
  Res : TRes;
  inf : TMemIniFile;
  s   : string;
begin
  if  (AnsiPos('<dl><dt>', Data) > 0) then  begin
    dl  :=  TResDownloader(Downloader);
    Res :=  TRes.Create;
    ParseDat(Data, 0, Res, ASubject);
    Res.No          :=  dl.ResList.Count + 1;
    Res.BBS         :=  dl.BBS;
    Res.Site        :=  dl.Site;
    Res.ThreadTitle :=  ASubject;
    if  (dl.ThreadItem.Title = '')  then  begin
      if  (ASubject <> '')  then  begin
        dl.ThreadItem.Title :=  ASubject;
      end;
    end;
    dl.FireDataEvt(Res, DownloadSize, TotalSize);
  end else
  if  (AnsiPos('<form', Data) = 1)  then  begin
    s   :=  ChangeFileExt(TResDownloader(Downloader).ThreadItem.LocalDatFileName, '.inf');
    inf :=  TMemIniFile.Create(s);
    inf.WriteString('AMEZOR', 'Footer', Data);
    inf.UpdateFile;
    inf.Free;
  end;
end;

//
//  X擾I
//
procedure TAmezorScript.ZonuEndRes(Sender: TObject; Downloader: TDownloader;
  Error: boolean);
var
  ParamData:  PParamData;
begin
  ParamData :=  PParamData(Downloader.ParamData);
  Dispose(ParamData);
  inherited;
end;

//
//  X擾G[
//
procedure TAmezorScript.ZonuResError(Sender: TObject; Downloader: TDownloader;
  ErrorCode: integer; ErrorMsg: string);
begin
  inherited;

end;

//
//  
//
procedure TAmezorScript.SendRes(Uploader: TResUploader);
var
  FZonuHttp : TZonuHttp;
begin
  FZonuHttp                 :=  TZonuHttp.Create(nil);
  FZonuHttp.Uploader        :=  Uploader;
  FZonuHttp.OnZonuSendEnd   :=  ZonuSendEnd;
  FZonuHttp.OnZonuSendError :=  ZonuSendError;
  FZonuHttp.Url             :=  GetSendUrl(Uploader.Board);
  FZonuHttp.UserAgent       :=  USER_AGENT;
  FZonuHttp.SendReferer     :=  ConvUrl2(Uploader.BBS.GetReadCgiUrl(Uploader.ThreadItem));
  FZonuHttp.SendContent     :=  Uploader.SendData.ConvSendContent(GetSendParam);
  FZonuHttp.SendCookie      :=  ''; //Uploader.SendData.ConvSendContent(GetSendCookie);
  FZonuHttp.Send;
end;

//
//  VX
//
procedure TAmezorScript.SendThread(Uploader: TThreadUploader);
var
  FZonuHttp   : TZonuHttp;
begin
  FZonuHttp                 :=  TZonuHttp.Create(nil);
  FZonuHttp.Uploader        :=  Uploader;
  FZonuHttp.OnZonuSendEnd   :=  ZonuSendEnd;
  FZonuHttp.OnZonuSendError :=  ZonuSendError;
  FZonuHttp.Url             :=  GetNewThreadUrl(Uploader.Board);
  FZonuHttp.UserAgent       :=  USER_AGENT;
  FZonuHttp.SendReferer     :=  Uploader.Board.Url;
  FZonuHttp.SendContent     :=  Uploader.SendData.ConvSendContent(GetNewThreadParam);
  FZonuHttp.SendCookie      :=  Uploader.SendData.ConvSendContent(GetNewThreadCookie);
  FZonuHttp.Send;
end;

function TAmezorScript.GetRelativeLink: boolean;
begin
  Result  :=  True;
end;

function TAmezorScript.ConvUrl(const Url: string): string;
var
  sl: TStringList;
  s: string;
  i: integer;
begin
  //  http://www.amezor.to/main1/020731212000.html
  //  http://www.amezor.to/cgi-bin/res.cgi?dir=main1&res=020731212000&ls=50
  if  (SameText(RightStr(Url, 5), '.html')) then  begin
    sl  :=  TStringList.Create;
    sl.CommaText  :=  StringReplace(Url, '/', ',', [rfReplaceAll]);
    if  (sl.Count > 0)  then  begin
      for i :=  0 to  sl.Count - 3  do  begin
        s :=  s + sl[i] + '/';
      end;
      s :=  s + 'cgi-bin/res.cgi?dir=' + sl[sl.Count - 2] + '&res=' + Copy(sl[sl.Count - 1], 1, Length(sl[sl.Count - 1]) - 5) + '&ls=50';
      Result  :=  s;
    end;
    sl.Free;
  end else begin
    Result  :=  Url;
  end;
end;

function TAmezorScript.ConvUrl2(const Url: string): string;
begin
  //  http://www.amezor.to/cgi-bin/res.cgi?dir=main1&res=020731212000&ls=50
  //  http://www.amezor.to/main1/020731212000.html
  Result  :=  'http://' + ExtractHostName(Url) +
              '/' + ChooseValue(Url, 'dir') +
              '/' + ChooseValue(Url, 'res') + '.html';

end;

end.
