{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 Common Library                                                    }
{                                                                             }
{ 2001-04 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit ZonuCommon;

interface

uses
  Classes, SysUtils, Windows, IniFiles, ZonuClass;

type
	TStrTokSeparator = set of Char;
	TStrTokRec = record
		Str: string;
		Pos: Integer;
	end;

  function ParseLocalDat(ALine: string; index: integer;
    var ARes: TRes; out ASubject: string): boolean;

  //Q˂
  procedure Parse2chSubject(subject: string; out FileName: string;
    out Title: string; out Count: integer);
  function Parse2chDat(ALine: string; index: integer;
    var ARes: TRes; out ASubject: string): boolean;

  //
  procedure ParseShitarabaSubject(subject: string; out FileName: string;
    out Title: string; out Count: integer);
  function ParseShitarabaDat(ALine: string; index: integer;
    var ARes: TRes; out ASubject: string): boolean;

  //тт
  procedure Parse15chSubject(subject: string; out FileName: string;
    out Title: string; out Count: integer);
  function Parse15chDat(ALine: string; index: integer;
    var ARes: TRes; out ASubject: string): boolean;

  //megabbs
  procedure ParseMegabbsSubject(subject: string; out FileName: string;
    out Title: string; out Count: integer);
  function ParseMegabbsDat(ALine: string; index: integer;
    var ARes: TRes; out ASubject: string): boolean;

  //12ch
  procedure Parse12chSubject(subject: string; out FileName: string;
    out Title: string; out Count: integer);
  function Parse12chDat(ALine: string; index: integer;
    var ARes: TRes; out ASubject: string): boolean;

  //JBBS
  function ParseJbbsDat(ALine: string; index: integer;
    var ARes: TRes; out ASubject: string): boolean;
  function ParseMachibbsDat(ALine: string; index: integer;
    var ARes: TRes; out ASubject: string): boolean;

  //Ahhan
  procedure ParseAhhanSubject(subject: string; out FileName: string;
    out Title: string; out Count: integer);
  function ParseAhhanDat(ALine: string; index: integer;
    var ARes: TRes; out ASubject: string): boolean;

  //1.5ch
  procedure Parse1_5Subject(subject: string; out FileName: string;
    out Title: string; out Count: integer);
  //function Parse1_5Dat(ALine: string; index: integer;
  //  var ARes: TRes; out ASubject: string): boolean;


  //Amezor
  procedure ParseAmezorSubject(subject: string; out FileName: string;
    out Title: string; out Count: integer);
  function ParseAmezorDat(ALine: string; index: integer;
    var ARes: TRes; out ASubject: string): boolean;

  //Amex0
  procedure ParseAmex0Subject(subject: string; out FileName: string;
    out Title: string; out Count: integer);
  function ParseAmex0Dat(ALine: string; index: integer;
    var ARes: TRes; out ASubject: string): boolean;


  //JBBS
  function ParseShitarabaJbbsDat(ALine: string; index: integer;
    var ARes: TRes; out ASubject: string): boolean;

  function DatFileNameToDatNo(const FileName: string): string;
  function Conv2chUrl(const Url: string): string;
  function Conv2chNewUrl(const OldUrl: string): string;
  function Conv2chDatUrlToReadCgiURL(const Url: string): string;
  function ConvShitarabaJbbsUrl(const Url: string): string;
  function Conv15chUrl(const Url: string): string;
  function Conv15chUrl2(const Url: string): string;

implementation

uses
  MonaUtils;

function DatFileNameToDatNo(const FileName: string): string;
var
 s : string;
begin
  s :=  ExtractFileName(FileName);
  if  (AnsiPos('.', s) > 0) then  begin
    Result  :=  Copy(s, 1, AnsiPos('.', s) - 1);
  end else begin
    Result  :=  s;
  end;
end;

(*************************************************************************
 *񂩂g[N̐؂o
 *Public iFDelphĩpNj
 *************************************************************************)
 // from  gikoNavi
function StrTokNext(const sep: TStrTokSeparator; var Rec: TStrTokRec): string;
var
	Len, I: Integer;
begin
	with Rec do	begin
		Len := Length(Str);
		Result := '';
		if Len >= Pos then begin
			while (Pos <= Len) and (Str[Pos] in sep) do begin
			 Inc(Pos);
			end;
			I := Pos;
			while (Pos<= Len) and not (Str[Pos] in sep) do begin
				if IsDBCSLeadByte(Byte(Str[Pos])) then begin
					Inc(Pos);
				end;
				Inc(Pos);
			end;
			Result := Copy(Str, I, Pos - I);
			while (Pos <= Len) and (Str[Pos] in sep) do begin// ͂D
				Inc(Pos);
			end;
		end;
	end;
end;

(*************************************************************************
 *񂩂g[N̐؂oij
 *Public iFDelphĩpNj
 *************************************************************************)
 // from  gikoNavi
function StrTokFirst(const s:string; const sep: TStrTokSeparator; var Rec: TStrTokRec): string;
begin
	Rec.Str := s;
	Rec.Pos := 1;
	Result := StrTokNext(sep, Rec);
end;

(*************************************************************************
 *TuWFNgs𕪊
 *Public
 *************************************************************************)
 //from gikoNavi
procedure Parse2chSubject(subject: string; out FileName: string;
  out Title: string; out Count: integer);
type
  TNichDivideType = (dtNoValue, dtTeri, dtTako, dtOther, dtNew);
  //  dtTeri  ....  DAT<>^Cg<JEg>
  //  dtTako  ....  DAT,^CgiJEgj
  //  dtOther ....  DAT,^Cg(JEg)
  //  dtNew ......  DAT<>^Cg(JEg)
var
	i: integer;
	ws: WideString;
	Rec: TStrTokRec;
  DivideType : TNichDivideType;
begin
	Count := 0;
  DivideType  :=  dtNoValue;

	if Copy(subject, Length(subject), 1) = '>' then begin
    DivideType  :=  dtTeri;
		i := Pos('<>', subject);
		FileName := Copy(subject, 1, i - 1);
		Title := Copy(subject, i + 2, Length(subject));
	end else begin
		i := Pos('<>', subject);
    if  (i > 0) then  begin
      DivideType  :=  dtNew;
      FileName := Copy(subject, 1, i - 1);
      Title := Copy(subject, i + 2, Length(subject));
    end else begin
  		FileName := Trim(StrTokFirst(subject, [','], Rec));
	  	Title := Trim(StrTokNext([','], Rec));
    end;
	end;

	ws := Trim(Title);
//	ws := Copy(ws, Length(ws) - 6, 7);

	if Copy(ws, Length(ws), 1) = ')' then begin
		//(nn)̏ꍇipJbRj
    if  (DivideType = dtNoValue)  then  DivideType  :=  dtOther;
		for i := Length(ws) - 1 downto 1 do begin
			if ws[i] = '(' then begin
				ws := Copy(ws, i + 1, Length(ws) - i - 1);
				if IsNumeric(ws) then
					Count := StrToInt(ws);
				Title := Trim(StringReplace(Title, '(' + ws + ')', '', [rfReplaceAll]));
				break;
			end;
		end;
	end else if Copy(ws, Length(ws), 1) = 'j' then begin
		//innj̏ꍇiSpJbRj
    if  (DivideType = dtNoValue)  then  DivideType  :=  dtTako;
		for i := Length(ws) - 1 downto 1 do begin
			if ws[i] = 'i' then begin
				ws := Copy(ws, i + 1, Length(ws) - i - 1);
				if IsNumeric(ws) then
					Count := StrToInt(ws);
        //takoT[o[Ή
				Title := Trim(StringReplace(Title, 'i' + ws + 'j', '', [rfReplaceAll]));
				break;
			end;
		end;
	end else begin
		//<nn>̏ꍇ
		for i := Length(ws) - 1 downto 1 do begin
			if ws[i] = '<' then begin
				ws := Copy(ws, i + 1, Length(ws) - i - 1);
				if IsNumeric(ws) then
					Count := StrToInt(ws);
				Title := Trim(StringReplace(Title, '<' + ws + '>', '', [rfReplaceAll]));
				break;
			end;
		end;
	end;
  if  (DivideType = dtTako) or (DivideType = dtOther) then  begin
    Title := StringReplace(Title, 'M',',',[rfReplaceAll]);
  end;
  Title :=  DecodeHtmlEsc(Title);
end;

function Parse2chDat(ALine: string; index: integer;
  var ARes: TRes; out ASubject: string): boolean;
var
  i, count : integer;
  //b : boolean;
begin
  if Length(ALine) > 0 then begin
    count     :=  0;
    ARes.ID :=  '';
    ARes.No :=  0;
    //b         :=  False;
    //**** 2001/06/10 begin
    //if  (Copy(ALine,Length(ALine) - 1,2) = '<>')  then  begin
    //  ALine     :=  StringReplace(ALine, ',', 'C', [rfReplaceAll]);
    //  b         :=  True;
    //end;
    //ALine     :=  StringReplace(ALine, '<>', ',', [rfReplaceAll]);
    //if (AnsiPos('<>', ALine) <= 0) then begin
    //  ALine := StringReplace(ALine, ',', '<>', [rfReplaceAll]);
    //  ALine := StringReplace(ALine, ',', ',', [rfReplaceAll]);
    //end;
    if (AnsiPos('<>', ALine) <= 0) then begin
      //J}؂
      ALine := StringReplace(ALine, ',', '<>', [rfReplaceAll]);
      ALine := StringReplace(ALine, 'M', ',', [rfReplaceAll]);
      ALine :=  StringReplace(ALine, '&amphearts;', '&hearts;', [rfReplaceAll]);
      ALine :=  StringReplace(ALine, '&amp#', '&#', [rfReplaceAll]);
    end;
    //**** 2001/06/10 end

    while true  do  begin
      //**** 2001/06/10 begin
      //i :=  AnsiPos(',', ALine);
      i := AnsiPos('<>', ALine);
      //**** 2001/06/10 end
      if  (i > 0) then  begin
        inc(count);
        case  count of
          1 : begin
                ARes.Name :=  Copy(ALine,1,i - 1);
                {
                AName :=  StringReplace(AName, '<b>', '', [rfReplaceAll, rfIgnoreCase]);
                AName :=  StringReplace(AName, '</b>', '', [rfReplaceAll, rfIgnoreCase]);
                AName :=  StringReplace(AName, '/b>', '', [rfReplaceAll, rfIgnoreCase]);
                }
                if  (AnsiPos('</b>',AnsiLowerCase(ARes.Name)) = 0) and
                    (AnsiPos('/b>',AnsiLowerCase(ARes.Name)) > 0) then
                begin
                  ARes.Name :=  StringReplace(ARes.Name, '/b>', '', [rfReplaceAll, rfIgnoreCase]);
                end;
              end;
          2 : begin
                ARes.Mail  :=  Copy(ALine,1,i - 1);
                if  (ARes.Mail <> '')  then  begin
                  ARes.Mail  :=  ARes.Mail; //
                end;
              end;
          3 : ARes.Date  :=  Copy(ALine,1,i - 1);
        end;
        //**** 2001/06/10 begin
        //ALine :=  Copy(ALine,i + 1,Length(ALine)-i);
        ALine := Copy(ALine,i + 2,Length(ALine)-i-1);
        //**** 2001/06/10 end
        if  (count = 3) then  break;
      end else begin
        Break;
      end;
    end;
    if  (index = 0) then  begin
      //**** 2001/06/10 begin
      //i :=  LastDelimiter(',', ALine);
      //if  (i > 0) then  begin
      //  ASubject  :=  MonaUtils.DecodeHtmlEsc(Copy(ALine,i+1,Length(ALine)-i));
      //  ALine     :=  Trim(Copy(ALine,1,i - 1));
      i := LastDelimiter('>', ALine);
      if (i > 0) then begin
        ASubject := MonaUtils.DecodeHtmlEsc(Copy(ALine,i+1,Length(ALine)-i));
        //ALine := Trim(Copy(ALine,1,i - 2));
        ALine := Copy(ALine,1,i - 2);
      //**** 2001/06/10 end
      end else begin
        ASubject  :=  '';
      end;
    end else begin
      //ALine     :=  Trim(ALine);
      ALine     :=  ALine;
      //**** 2001/06/10 begin
      //if  (b) then  ALine :=  StringReplace(ALine,'C',',',[rfReplaceAll]);
      //if  (ALine[Length(ALine)] = ',')  then  ALine :=  Copy(ALine,1,Length(ALine) - 1);
      //if (Copy(ALine,Length(ALine) - 1, 2) = '<>') then
      //  ALine := Copy(ALine,1,Length(ALine) - 2);
      if (AnsiPos('<>', ALine) > 0) then  begin
        ALine := Copy(ALine,1,AnsiPos('<>', ALine) - 1);
      end;
      //**** 2001/06/10 end
    end;
    //**** 2001/06/10 begin
    //ABody  :=  StringReplace(ALine,'M',',',[rfReplaceAll]) + '<BR><BR>';
    ARes.Body := ALine; // + '<BR><BR>';
    //**** 2001/06/10 end
    if  (AnsiPos('ID:', ARes.Date) > 0)  then  begin
      ARes.ID :=  Copy(ARes.Date, AnsiPos('ID:', ARes.Date) + 3, Length(ARes.Date));
      ARes.Date :=  Trim(Copy(ARes.Date, 1, AnsiPos('ID:', ARes.Date) - 1));
    end;
    Result :=  True;
  end else begin
    Result :=  False;
  end;
end;

procedure ParseShitarabaSubject(subject: string; out FileName: string;
  out Title: string; out Count: integer);
begin
  //蔲ȁAAAA
  FileName  :=  ChooseString(subject, '<>', 0);
  Title     :=  DecodeHtmlEsc(ChooseString(subject, '<>', 1));
  Count     :=  StrToIntDef(ChooseString(subject, '<>', 2), 0);
end;

function ParseShitarabaDat(ALine: string; index: integer;
  var ARes: TRes; out ASubject: string): boolean;
var
  s : string;
begin
  if Length(ALine) > 0 then begin
    s :=  ALine;
    //񂩂ȁH
    s :=  StringReplace(S, 'M', ',', [rfReplaceAll]);
    s :=  StringReplace(S, '&amphearts;', '&hearts;', [rfReplaceAll]);
    s :=  StringReplace(S, '&amp#', '&#', [rfReplaceAll]);
    ARes.Name :=  ChooseString(S, '<>', 0);
    ARes.Mail :=  ChooseString(S, '<>', 1);
    ARes.Date :=  ChooseString(S, '<>', 2);
    ARes.Body :=  ChooseString(S, '<>', 3);
    ARes.Id   :=  '';
    ARes.No   :=  0;
    if  (index = 0) then  begin
      ASubject  :=  ChooseString(S, '<>', 4);
    end else begin
      ASubject  :=  '';
    end;
    //if  (ARes.Mail <> '') then  ARes.Mail :=  'mailto:' + ARes.Mail;
    Result  :=  True;
  end else begin
    Result  :=  False;
  end;
end;

procedure Parse15chSubject(subject: string; out FileName: string;
  out Title: string; out Count: integer);
var
  s : string;
begin
  //<b>1</b> : (107) <a href="./readres.cgi?bo=lobby&vi=1364&rm=50" target="_blank">䕂݂̂ȂŃKfBEX۰</a><BR>
  //<b>60</b> :@(36) <a href="./readres.cgi?bo=lobby&vi=1530&rm=50">тт͑ς炸ȁ</a> <font color="#cccccc">[1530] </font>@<BR>
  s :=  Copy(subject, AnsiPos('(', subject) + 1, Length(subject));
  s :=  Trim(Copy(s, 1, AnsiPos(')', s) - 1));
  Count :=  StrToIntDef(s, 0);

  s :=  Copy(subject, AnsiPos('vi=', subject) + 3, Length(subject));
  s :=  Copy(s, 1, AnsiPos('&', s) - 1);
  FileName  :=  s;

  s :=  Copy(subject, AnsiPos('rm=50">', subject) + 7, Length(subject));
  s :=  Copy(s, 1, AnsiPos('</a>', s) - 1);
  Title :=  DecodeHtmlEsc(s);
end;

function Parse15chDat(ALine: string; index: integer;
  var ARes: TRes; out ASubject: string): boolean;
var
  s, sx : string;
  AName : string;
begin
  //<br>@<dt>04:  <font color="forestgreen"><b><font color="#335544">OGX</font></b></font>@ 2000/12/22(Fri) 14:38<dd><tt>ȂWs^[<br>mXg_X̑\<br>fB[vCpNg</tt>
  //<br>@<dt>38:  <font color="forestgreen"><b>The Movie</b></font>@ 2001/09/17(Mon) 18:08<dd>37<br>ˁB<br>ӊOƋr{Ȃ񂩂e肷邵EEEB
  //<br>@<dt>81:  <font color="forestgreen"><b><a href="mailto:ݏ">ݏ</a></b></font>@ 2002/03/13(Wed) 22:04<dd>ݏ
  S   :=  Copy(ALine, AnsiPos('<dt>', ALine) + 4, Length(ALine));
  ARes.No :=  StrToIntDef(Copy(S, 1, AnsiPos(':', S) - 1), 0);

  //'<a href="mailto:sage">̃}[`</a>'
  S     :=  Copy(ALine, AnsiPos('<b>', ALine) + 3, Length(ALine));
  AName :=  Copy(S, 1, AnsiPos('</b></font>', S) - 1);
  if  (AnsiPos('mailto:', AName) > 0) then  begin
    ARes.Name :=  TrimHRefTag(AName);
    sx  :=  Copy(AName, AnsiPos('<a href="mailto:', AName), Length(AName));
    sx  :=  Copy(sx, 17, Length(sx));
    ARes.Mail :=  Copy(sx, 1, AnsiPos('">', sx) - 1);
  end else begin
    ARes.Name :=  AName;
    ARes.Mail :=  '';
  end;

  //OGX</font></b></font>@ 2000/12/22(Fri) 14:38<dd><tt>ȂWs^[<br>mXg_X̑\<br>fB[vCpNg</tt>
  //The Movie</b></font>@ 2001/09/17(Mon) 18:08<dd>37<br>ˁB<br>ӊOƋr{Ȃ񂩂e肷邵EEEB
  //ݏ</a></b></font>@ 2002/03/13(Wed) 22:04<dd>ݏ

  S     :=  Copy(ALine, AnsiPos('</b></font>', ALine) + 13, Length(ALine));
  S     :=  Trim(Copy(S, 1, AnsiPos('<dd>', S) - 1));
  if  (Copy(S, 1, 2) = '@')  then  begin
    S :=  Copy(S, 3, Length(S));
  end;
  ARes.Date :=  Trim(S);

  ARes.ID   :=  '';

  //<tt><font color="#efefef">[ bbOnIChigo ]</font></tt>
  {
  if  (AnsiPos('<tt><font color="#efefef">[', ALine) > 0) then  begin
    s :=  Copy(ALine, AnsiPos('<tt><font color="#efefef">[', ALine), Length(ALine));
    s :=  Copy(s, 1,  AnsiPos('</font></tt>', s));
    s :=  Copy(s, AnsiPos('[', s) + 1, Length(s));
    s :=  Copy(s, 1, AnsiPos(']', s) - 1);
    s :=  Trim(s);
    if  (s <> '') then  begin
      ARes.ID :=  s;
    end;
  end;
  }

  S     :=  Copy(ALine, AnsiPos('<dd>', ALine) + 4, Length(ALine));
  ARes.Body :=  TrimHrefTag(S);

  ASubject  :=  '';
  Result    :=  True;
end;

procedure ParseMegabbsSubject(subject: string; out FileName: string;
  out Title: string; out Count: integer);
var
  s, sx     : string;
  n, m   : integer;
begin
  //<a href="readres.cgi?bo=haihu&vi=0001"><b>1</b>: Mega BBSXNvgzzT|[g(107)</a>
  //<a href="readres.cgi?bo=haihu&vi=999027289"><b>2</b>: Ȃ񂾂̐́H(9)</a>
  s :=  Copy(subject, AnsiPos('vi=', subject) + 3, Length(subject));
  s :=  Copy(s, 1, AnsiPos('"', s) - 1);
  FileName  :=  s;
  //s :=  Copy(subject, AnsiPos('<b>', subject) + 3, Length(subject));
  //s :=  Copy(s, 1, AnsiPos('<', s));
  //Count :=  StrToIntDef(s, 0);
  s :=  Copy(subject, AnsiPos(':', subject) + 1, Length(subject));
  s :=  Trim(Copy(s, 1, AnsiPos('</a>', s) - 1));
  sx  :=  s;
  n   :=  0;
  while true  do  begin
    m :=  AnsiPos('(', sx);
    if  (m < 1) then  Break;
    n   :=  n + m;
    sx  :=  Copy(sx, n + 1, Length(sx));
  end;
  Title :=  DecodeHtmlEsc((Copy(s, 1, n - 1)));
  Count :=  StrToIntDef(Copy(s, n + 1, Length(s) - 1 - n), 0);
end;

function ParseMegabbsDat(ALine: string; index: integer;
  var ARes: TRes; out ASubject: string): boolean;
var
  s : string;
begin
  ASubject  :=  '';
  if  (Length(ALine) > 0) then  begin

    S   :=  Copy(ALine, 1, AnsiPos('</a>', ALine) - 1);
    ARes.No :=  StrToIntDef(TrimTag(S), 0);

    S   :=  Copy(ALine, AnsiPos('<B>', ALine) + 3, Length(ALine));
    S   :=  Copy(S, 1, AnsiPos('</B>', S) - 1);
    //<a href="mailto:sage "><font color=#99958C>dax</font></a>
    if  (AnsiPos('<a href="mailto:', S) = 1)  then  begin
      S :=  Copy(S, AnsiPos('mailto:', S) + 7, Length(S));
      ARes.Mail :=  Copy(S, 1, AnsiPos('"', S) - 1);
    end;

    S   :=  Copy(ALine, AnsiPos('<B>', ALine) + 3, Length(ALine));
    S   :=  Copy(S, 1, AnsiPos('</B>', S) - 1);
    //<a href="mailto:sage "><font color=#99958C>dax</font></a>
    if  (AnsiPos('<a href="mailto:', S) = 1)  then  begin
      S :=  Copy(S, AnsiPos('>', S) + 1, Length(S));
      S :=  Copy(S, 1, AnsiPos('</a>', S) - 1);
      ARes.Name :=  S;
    end else begin
      ARes.Name :=  S;
    end;

    S :=  Copy(ALine, AnsiPos('</B>', ALine) + 4, Length(ALine));
    S :=  Trim(Copy(S, 1, AnsiPos('<', S) - 1));
    if  (Copy(S,1,2) = '@')  then  //擪̑SpXy[X
      ARes.Date :=  Copy(S, 3, Length(S))
    else
      ARes.Date :=  S;

    S :=  Copy(ALine, AnsiPos('<DD>', ALine) + 4, Length(ALine));
    ARes.Body :=  Copy(S, 1, AnsiPos('<hr', S) - 1);

    Result  :=  True;
  end else begin
    Result  :=  False;
  end;
end;

procedure Parse12chSubject(subject: string; out FileName: string;
  out Title: string; out Count: integer);
var
  s, sx     : string;
  n, m   : integer;
begin
  //<a href=../read.cgi?bbs=entrance&key=1006428535>1</a>:<a href=../read.cgi?bbs=entrance&key=1006428535&ls=50>Jjgbv}`łƏ،X&lt;8&gt;</a><br>
  //                                     *FileName*                                            *FileName*       *Title*                                *Count*
  s :=  Copy(subject, AnsiPos('key=', subject) + 4, Length(subject));
  s :=  Copy(s, 1, AnsiPos('>', s) - 1);
  FileName  :=  s;

  //
  s :=  Copy(subject, AnsiPos(':', subject) + 1, Length(subject));
  s :=  Trim(Copy(s, 1, AnsiPos('</a>', s) - 1));
  //<a href=../read.cgi?bbs=entrance&key=1006428535&ls=50>Jjgbv}`łƏ،X&lt;8&gt;
  s :=  Copy(s, AnsiPos('>', s) + 1, Length(s));
  //Jjgbv}`łƏ،X&lt;8&gt;

  sx  :=  s;
  n   :=  0;
  while true  do  begin
    m :=  AnsiPos('&lt;', sx);
    if  (m < 1) then  Break;
    n   :=  n + m;
    sx  :=  Copy(sx, n + 1, Length(sx));
  end;
  Title :=  DecodeHtmlEsc(Copy(s, 1, n - 1));
  s     :=  Copy(s, n + 4, Length(s));
  Count :=  StrToIntDef(Copy(s, 1, AnsiPos('&gt;', s) - 1), 0);
end;

function Parse12chDat(ALine: string; index: integer;
  var ARes: TRes; out ASubject: string): boolean;
var
  s, sx : string;
begin
  ASubject  :=  '';
  //'<dl><dt>1 OF <b><font color=forestgreen><b></b></font></b> eF2001/11/29() 22:44<dd>oϿ<br>g쉮RsyWFl[^[<br><a href=http://8931.com/yosinoya.php3 target=_blank>http://8931.com/yosinoya.php3</a><br>ǂH<br><br>'
  //'<dt>2 OF <b><font color=forestgreen><b></b></font></b> eF2001/12/04() 16:27<dd><br><br>'
  if  (Length(ALine) > 0) then  begin
    S   :=  Copy(ALine, AnsiPos('<dt>', ALine) + 4, Length(ALine));
    S   :=  Copy(S, 1, AnsiPos(' ', S) - 1);
    ARes.No :=  StrToIntDef(S, 0);

    //<b><font color=forestgreen><b></b></font></b> eF2001/11/29() 22:44<dd>oϿ<br>g쉮RsyWFl[^[<br><a href=http://8931.com/yosinoya.php3 target=_blank>http://8931.com/yosinoya.php3</a><br>ǂH<br><br>'
    //<b><a href=mailto:sage><b></b></a></b> eF2001/12/04() 16:27<dd><br><br>'

    //**<dt>2 OF <font color=forestgreen><b>Ȁ̎q</b></font>
    //**<dt>10 OF <a href=mailto:IIII><b>AhoCU[</b></a> eF2003/11/23() 19:15
    
    S   :=  Copy(ALine, AnsiPos('<b>', ALine) + 3, Length(ALine));
    S   :=  Copy(S, 1, AnsiPos('</b>', S) - 1);

    //<font color=#cc0000><b>ܡE/b></font>
    //<a href=mailto:sage><b>ܡE/b></a>
    sx  :=  Copy(ALine, 1, AnsiPos('</b>', ALine) - 1);
    if  (AnsiPos('<a href=mailto:', sx) > 1)  then  begin
      sx :=  Copy(sx, AnsiPos('mailto:', sx) + 7, Length(sx));
      ARes.Mail :=  Copy(sx, 1, AnsiPos('>', sx) - 1);
    end;

    ARes.Name :=  S;

    //
    //eF2001/11/17() 21:23<dd>ǤΤǡA Bone٤κͤȤ̵طǤ<br><br>
    S :=  Copy(ALine, AnsiPos('eF', ALine) + 8, Length(ALine));
    S :=  Trim(Copy(S, 1, AnsiPos('<dd>', S) - 1));
    ARes.Date :=  S;

    //
    S :=  Copy(ALine, AnsiPos('<dd>', ALine) + 4, Length(ALine));
    if  (Copy(S, Length(S) - 7, 8) = '<br><br>')  then  begin
      S :=  Copy(S, 1, Length(S) - 8);
    end;
    ARes.Body :=  S;

    Result  :=  True;
  end else begin
    Result  :=  False;
  end;
end;

function ParseJbbsDat(ALine: string; index: integer;
  var ARes: TRes; out ASubject: string): boolean;
const
  SEND_DATE = ' eF ';
var
  //Parser : TMonaHtmlParser;
  s, sx : string;
  //b : boolean;
  //i : integer;
  n : integer;
begin
  if  (Length(ALine) > 0) then  begin
    //<dt>18 OF<a href="mailto:sage"><b> gikochan </B></a> eF 2001/05/17() 01:34<br>
    //<dd>܂łĂoi[\Ȃ̂ŁAoi[\Ȃɂ܂B <br><br>

    //<dt>1 OF<font color="#008800"><b> ł悩H </b></font> eF 2001/11/15() 11:45 ID:8yxJoMcY <font size=1>[ MOJcd-01p131.ppp.odn.ad.jp ]</font><br>
    //<dd> RɂuHv͂B@łB<br>uԊԉwOŃJ[n߂ĂRONvƂŔڈB  <br><br>

    //<dt>6 OF<a href="mailto:E\ł(*^.^*)Gwbi"><b> ł悩H </B></a> eF 2001/11/05() 18:01 ID:/EZqFIzI <font size=1>[ fuku-ip1.ppp208.coara.or.jp]</font><br>
    //<dd> cdcВ̐c  <br><br>

    //No
    n :=  AnsiPos('OF', ALine);
    ARes.No     :=  StrToIntDef(Trim(Copy(ALine, 5, n - 5)), 0);

    //Mail
    S       :=  Trim(Copy(ALine, AnsiPos('OF', ALine) + 6, Length(ALine)));
    if  (AnsiPos('<a href', AnsiLowerCase(S)) = 1) then  begin
      sx    :=  Copy(s, 17, Length(s));
      sx    :=  Copy(sx, 1, AnsiPos('">', sx) - 1);
      //<a href="mailto:sage"><b>
      ARes.Mail :=  sx;
      //S     :=  '<b>' + s;
    end else begin
      ARes.Mail :=  '';
    end;

    //O
    S       :=  Copy(S, AnsiPos('<b>', S) + 3, Length(S));
    if  (AnsiPos('</b></a> eF', AnsiLowerCase(S)) > 0)  then  begin
      sx      :=  Trim(Copy(S,1,AnsiPos('</b></a>', AnsiLowerCase(S)) - 1));
    end else begin
      sx      :=  Trim(Copy(S,1,AnsiPos('</b></font>', AnsiLowerCase(S)) - 1));
    end;
    if  (ARes.Mail <> '')  then  begin
      ARes.Name   :=  TrimHRefTag(sx);
    end else begin
      ARes.Name   :=  sx;
    end;

    //
    S :=  Copy(S, AnsiPos('eF', S) + 8, Length(S));
    n :=  AnsiPos('ID:', S);
    if  (n > 0) then  begin
      //2001/11/05() 18:01 ID:/EZqFIzI <font size=1>[ fuku-ip1.ppp208.coara.or.jp]</font><br>
      ARes.Date   :=  Trim(Copy(S, 1, n - 1));
      S :=  Copy(S, n, Length(s));
      n :=  AnsiPos('<', S);
      ARes.ID     :=  Trim(Copy(S, 4, n - 1 - 4));
      S :=  Copy(S, n, Length(s));
      n :=  AnsiPos('[', S);
      if  (n > 0) then  begin
        ARes.RemoteHost :=  Trim(Copy(S, n + 1, AnsiPos('</font>', S) - n - 1));
        if  (ARes.RemoteHost <> '') then  begin
          if  (Copy(ARes.RemoteHost, Length(ARes.RemoteHost), 1) = ']') then  begin
            ARes.RemoteHost :=  Trim(Copy(ARes.RemoteHost, 1, Length(ARes.RemoteHost) - 1));
          end;
        end;
      end;
    end else begin
      ARes.Date   :=  Trim(Copy(S,1, AnsiPos('<br>', AnsiLowerCase(S)) - 1));
      ARes.ID     :=  '';
    end;

    //
    s       :=  Trim(Copy(S, AnsiPos('<dd>', AnsiLowerCase(S)) + 4, Length(S)));
    //<br><br>
    if  (Copy(S, Length(S) - 7, 8) = '<br><br>')  then  begin
      s :=  Copy(S, 1, Length(S) - 9);
    end;
    ARes.Body   :=  S;
    Result  :=  True;
  end else begin
    Result  :=  False;
  end;
end;
{
function ParseJbbsDat(ALine: string; index: integer;
  var ARes: TRes; out ASubject: string): boolean;
const
  SEND_DATE = ' eF ';
var
  //Parser : TMonaHtmlParser;
  s, sx : string;
  //b : boolean;
  //i : integer;
  n : integer;
begin
  if  (Length(ALine) > 0) then  begin
    //<dt>18 OF<a href="mailto:sage"><b> gikochan </B></a> eF 2001/05/17() 01:34<br>
    //<dd>܂łĂoi[\Ȃ̂ŁAoi[\Ȃɂ܂B <br><br>

    //<dt>1 OF<font color="#008800"><b> ł悩H </b></font> eF 2001/11/15() 11:45 ID:8yxJoMcY <font size=1>[ MOJcd-01p131.ppp.odn.ad.jp ]</font><br>
    //<dd> RɂuHv͂B@łB<br>uԊԉwOŃJ[n߂ĂRONvƂŔڈB  <br><br>

    //<dt>6 OF<a href="mailto:E\ł(*^.^*)Gwbi"><b> ł悩H </B></a> eF 2001/11/05() 18:01 ID:/EZqFIzI <font size=1>[ fuku-ip1.ppp208.coara.or.jp]</font><br>
    //<dd> cdcВ̐c  <br><br>

    //No
    n :=  AnsiPos('OF', ALine);
    ARes.No     :=  StrToIntDef(Trim(Copy(ALine, 5, n - 5)), 0);

    //Mail
    S       :=  Trim(Copy(ALine, AnsiPos('OF', ALine) + 6, Length(ALine)));
    if  (AnsiPos('<a href', AnsiLowerCase(S)) = 1) then  begin
      sx    :=  Copy(s, 17, Length(s));
      sx    :=  Copy(sx, 1, AnsiPos('">', sx) - 1);
      //<a href="mailto:sage"><b>
      ARes.Mail :=  sx;
      //S     :=  '<b>' + s;
    end else begin
      ARes.Mail :=  '';
    end;

    //O
    S       :=  Copy(S, AnsiPos('<b>', S) + 3, Length(S));
    sx      :=  Trim(Copy(S,1,AnsiPos('</b></font>', AnsiLowerCase(S)) - 1));
    if  (ARes.Mail <> '')  then  begin
      ARes.Name   :=  TrimHRefTag(sx);
    end else begin
      ARes.Name   :=  sx;
    end;

    //
    S :=  Copy(S, AnsiPos('eF', S) + 8, Length(S));
    n :=  AnsiPos('ID:', S);
    if  (n > 0) then  begin
      //2001/11/05() 18:01 ID:/EZqFIzI <font size=1>[ fuku-ip1.ppp208.coara.or.jp]</font><br>
      ARes.Date   :=  Trim(Copy(S, 1, n - 1));
      S :=  Copy(S, n, Length(s));
      n :=  AnsiPos('<', S);
      ARes.ID     :=  Trim(Copy(S, 4, n - 1 - 4));
      S :=  Copy(S, n, Length(s));
      n :=  AnsiPos('[', S);
      if  (n > 0) then  begin
        ARes.RemoteHost :=  Trim(Copy(S, n + 1, AnsiPos('</font>', S) - n - 1));
        if  (ARes.RemoteHost <> '') then  begin
          if  (Copy(ARes.RemoteHost, Length(ARes.RemoteHost), 1) = ']') then  begin
            ARes.RemoteHost :=  Trim(Copy(ARes.RemoteHost, 1, Length(ARes.RemoteHost) - 1));
          end;
        end;
      end;
    end else begin
      ARes.Date   :=  Trim(Copy(S,1, AnsiPos('<br>', AnsiLowerCase(S)) - 1));
      ARes.ID     :=  '';
    end;

    //
    s       :=  Trim(Copy(S, AnsiPos('<dd>', AnsiLowerCase(S)) + 4, Length(S)));
    //<br><br>
    if  (Copy(S, Length(S) - 7, 8) = '<br><br>')  then  begin
      s :=  Copy(S, 1, Length(S) - 9);
    end;
    ARes.Body   :=  S;
    Result  :=  True;
  end else begin
    Result  :=  False;
  end;
end;
}
function ParseLocalDat(ALine: string; index: integer;
  var ARes: TRes; out ASubject: string): boolean;
var
  s : string;
  n, n1, n2 : integer;
begin
  n         :=  AnsiPos('<>', ALine);
  ARes.Name :=  Copy(ALine, 1, n - 1);
  S         :=  Copy(ALine, n + 2, Length(ALine));

  n         :=  AnsiPos('<>', S);
  ARes.Mail :=  Copy(S, 1, n - 1);
  S         :=  Copy(S, n + 2, Length(S));

  n         :=  AnsiPos(' ID:', S);
  if  (n > 0) and (n < AnsiPos('<>', S)) then  begin
    ARes.Date :=  Copy(S, 1, n - 1);
    S         :=  TrimLeft(Copy(S, n + 4, Length(S)));
    n1        :=  AnsiPos(' ', S);
    n2        :=  AnsiPos('<>', S);
    if  (n1 < n2) and (n1 > 0) then  begin
      ARes.ID :=  Copy(S, 1, n1 - 1);
      S       :=  Copy(S, n1 + 1, Length(S));
      n       :=  AnsiPos('<>', S);
      ARes.RemoteHost  :=  Copy(S, 1, n - 1);
      S       :=  Copy(S, n + 2, Length(S));
    end else begin
      ARes.ID :=  Copy(S, 1, n2 - 1);
      S       :=  Copy(S, n2 + 2, Length(S));
      ARes.RemoteHost  :=  '';
    end;
  end else begin
    n         :=  AnsiPos('<>', S);
    ARes.Date :=  Copy(S, 1, n - 1);
    S         :=  Copy(S, n + 2, Length(S));
  end;

  n         :=  AnsiPos('<>', S);
  ARes.Body :=  Copy(S, 1, n - 1);
  S         :=  Copy(S, n + 2, Length(S));

  if  (S <> '') then  begin
    ASubject  :=  S;
    ARes.ThreadTitle  := ASubject;
  end;
  
  Result    :=  True;
end;

//
//  VURLɕϊ
//
function Conv2chUrl(const Url: string): string;
{original code : HOTZONU1.0b Zonutils.pas <NichReadCgiUrlNewToOld>}
var
  n : integer;
  s, r,stx, tox, nof : string;
  DatNo : string;
begin
  n :=  AnsiPos('/read.cgi/', Url);
  if  (n > 0) then  begin
    // http://piza2.2ch.net/test/read.cgi/tech/1000035521/
    // http://piza2.2ch.net/test/read.cgi?bbs=tech&key=1000035521
    s := Copy(Url, n + 1, Length(Url));
    // s =  read.cgi/tech/1000035521/
    r  :=  Copy(Url, 1, n) + 'read.cgi' +
                             '?bbs=' + ChooseString(s, '/', 1) +
                             '&key=' + ChooseString(s, '/', 2);
    s :=  ChooseString(s, '/', 3);
    if  (AnsiPos('-', s) > 0)  then  begin
      stx :=  ChooseString(s, '-', 0);
      tox :=  ChooseString(s, '-', 1);
      if  (AnsiPos('n', tox) > 0) then  begin
        tox :=  StringReplace(tox, 'n', '', [rfReplaceAll]);
        nof :=  '&nofirst=true';
      end else begin
        nof :=  '';
      end;
      if  (stx <> '') then  r :=  r + '&st=' + stx;
      if  (tox <> '') then  r :=  r + '&to=' + tox;
    end else
    if  (s <> '') then  begin
      if  (AnsiPos('n', s) > 0) then  begin
        s   :=  StringReplace(s, 'n', '', [rfReplaceAll]);
        nof :=  '&nofirst=true';
      end else begin
        nof :=  '';
      end;
      stx :=  s;
      tox :=  s;
      r :=  r + '&st=' + stx;
      r :=  r + '&to=' + tox;
    end;
    Result  :=  r + nof;
  end else
  //http://teri.2ch.net/accuse/kako/998/998759338.html
  //http://piza.2ch.net/log/sci/kako/939/939217336.html
  //http://teri.2ch.net/test/read.cgi?bbs=accuse&key=998759338
  if  (AnsiPos('/kako/', Url) > 0)  then  begin
    DatNo :=  ExtractUrlName(Url);
    if  (AnsiPos('.htm', DatNo) > 0)  then  begin
      DatNo :=  Copy(DatNo, 1, AnsiPos('.htm', DatNo) - 1);
    end;
    s :=    ChooseString(Url, '/', 3);
    if  (SameText(s, 'log')) then  begin
      s :=  ChooseString(Url, '/', 4);
    end;
    Result  :=  'http://' +
                ExtractHostName(Url) + '/test/read.cgi' +
                '?bbs=' + s +
                '&key=' + DatNo
  end else begin
    Result  :=  Url;
  end;
end;

//
//  VURLɕϊ
//
function Conv15chUrl(const Url: string): string;
var
  n : integer;
  s, r,stx, tox, nof : string;
  DatNo : string;
begin
  n :=  AnsiPos('/15bbs/', Url);
  if  (n > 0) then  begin
    // http://www.ichigobbs.net/cgi/15bbs/ichigo/0067/L30
    // http://www.ichigobbs.net/cgi/readres.cgi?bo=ichigo&vi=0063&rm=50
    s := Copy(Url, n + 1, Length(Url));
    // s =  15bbs/ichigo/0067/L30
    r   :=  Copy(Url, 1, n - 1) + '/readres.cgi'  +
                             '?bo=' + ChooseString(s, '/', 1) +
                             '&vi=' + ChooseString(s, '/', 2);
    s :=  ChooseString(s, '/', 3);                             
    if  (AnsiPos('-', s) > 0)  then  begin
      stx :=  ChooseString(s, '-', 0);
      tox :=  ChooseString(s, '-', 1);
      if  (AnsiPos('n', tox) > 0) then  begin
        tox :=  StringReplace(tox, 'n', '', [rfReplaceAll]);
        nof :=  '&fi=no';
      end else begin
        nof :=  '';
      end;
      if  (stx <> '') then  r :=  r + '&rs=' + stx;
      if  (tox <> '') then  r :=  r + '&re=' + tox;
    end else
    if  (s <> '') then  begin
      if  (AnsiPos('n', s) > 0) then  begin
        s   :=  StringReplace(s, 'n', '', [rfReplaceAll]);
        nof :=  '&fi=no';
      end else begin
        nof :=  '';
      end;
      stx :=  s;
      tox :=  s;
      r :=  r + '&rs=' + stx;
      r :=  r + '&re=' + tox;
    end;
    Result  :=  r + nof;
  end else
  Result  :=  Url;
end;

function Conv15chUrl2(const Url: string): string;
var
  s, sx: string;
begin
  if  (AnsiPos('?', Url) > 0) then  begin
    s   :=  Copy(Url, AnsiPos('bo=', Url) + 3, Length(Url));
    s   :=  Copy(s, 1, AnsiPos('&', s) - 1);
    sx  :=  Copy(Url, 1, AnsiPos('/readres.cgi', Url))  + '15bbs/' + s;
    s   :=  Copy(Url, AnsiPos('vi=', Url) + 3, Length(Url));
    if  (AnsiPos('&', s) > 0) then  begin
      s   :=  Copy(s, 1, AnsiPos('&', s) - 1);
    end;
    s   :=  sx  + '/' + s + '/';
  end else begin
    s   :=  Url;
  end;
  Result  :=  s;
end;


procedure ParseAhhanSubject(subject: string; out FileName: string;
  out Title: string; out Count: integer);
var
  s, sx     : string;
  n, m   : integer;
begin
  //<FONT title= 0019 ><A href="./mibbs.cgi?mo=p&fo=entrn&tn=0019&rn=30" target="_blank"><B>1</B> :؂̃RenQ(863)</A></FONT>@
  //<font title= 0017 ><a href="./mibbs.cgi?mo=p&fo=mes&tn=0017&rn=30" target="_blank"><b>1</b> :JɗޓeK̕sɂ(01)</a></font>@

  s :=  Copy(subject, AnsiPos('&tn=', subject) + 4, Length(subject));
  s :=  Copy(s, 1, AnsiPos('&rn', s) - 1);
  FileName  :=  s;

  //؂̃RenQ(863)
  //JɗޓeK̕sɂ(01)
  s :=  Copy(subject, AnsiPos(':', subject) + 1, Length(subject));
  s :=  Trim(Copy(s, 1, AnsiPos('</a>', s) - 1));
  sx  :=  s;
  n   :=  0;
  while true  do  begin
    m :=  AnsiPos('(', sx);
    if  (m < 1) then  Break;
    n   :=  n + m;
    sx  :=  Copy(sx, n + 1, Length(sx));
  end;
  Title :=  DecodeHtmlEsc(Copy(s, 1, n - 1));
  Count :=  StrToIntDef(Copy(s, n + 1, Length(s) - 1 - n), 0);
end;

function ParseAhhanDat(ALine: string; index: integer;
  var ARes: TRes; out ASubject: string): boolean;
var
  s, sx : string;
begin
  //<dt>28: OF<font color="#228b22"><b></b></font><font size="2">eF2001/12/05() 00:37</font><dd><font color="#b22222">&gt;27 </font><br>
  //
  //ȃN\{P<br>
  //
  // <p>
  //
  //<dt>29: OF<font color="#335544"><b></b></font><font size="2">eF2001/12/05() 02:26</font><dd>r[̃gbvꂶႠ˂EEE<br>
  //
  // <p>
  //
  //<dt>39: OF<b><a href="mailto:|"><FONT COLOR = "#FF69B4">炭</font></a></b><font size="2">eF2001/12/04() 20:23</font><dd>͉񂾁H<br>
  //
  // <p>
  //
  //<dt>18: OF<b><a href="mailto:߂ȂI">Ȃ</a></b></b>&nbsp;<font size="2">eF2001/09/10() 23:26 @ <font color="#cc3681">EEE1ip</font>
  //</font><dd>˂ƏĂāEEEI<br>
  //
  // <p>
  //
  //<dt>19: OF<b><a href="mailto:߂ȂI">Ȃ</a></b></b>&nbsp;<font size="2">eF2001/09/10() 23:27 @ <font color="#cc3681">EEE1ip</font>
  //</font><dd>A܂B<br>
  //
  // <p>
  //
  //<dt>20: OF<b><a href="mailto:߂ȂI">Ȃ</a></b></b>&nbsp;<font size="2">eF2001/09/10() 23:28 @ <font color="#cc3681"></font>
  //</font><dd>[EEEB<br>
  //
  // <p>
  //
  {
<dt><a href="./mibbs.cgi?mo=p&fo=hihan&tn=0341&rs=115&re=115&rf=no&al=on" target="_new">115</a>: OF<font color="#228b22"><b>TQ</b></font><font size="2">eF2002/05/28() 02:25</font>
<dd>Ȃ݂ɁcTRC̑gD͑傫Ɂi͎OȁHj<br>
YOSAKOI\[wsψi{eBAj<br>
IɊԈႢ邩Ă܂񂪁A\߂<br>

ȗ܂@<a href="./mibbs.cgi?mo=p&fo=hihan&tn=0341&rs=115&re=115&rf=no&al=on" target="_new">[S]</a><br>

 <p>

<dt>01: OF<font color="#228b22"><b></b></font><font size="2">eF2002/09/08() 01:25&nbsp&nbsp<a href ="http://210.153.99.120/cgi-bin/bbs/abi.cgi?mo=delreq&fo=entrn&tn=0013&rs=01&re=01">폜˗</a></font><dd>212chŌ|Չ񍐂I<br>

  }
  ASubject  :=  '';
  if  (Length(ALine) > 0) then  begin
    if  (AnsiPos('<dt><a', ALine) > 0)  then  begin
      S   :=  Copy(ALine, AnsiPos('">', ALine) + 2, Length(ALine));
      S   :=  Copy(S, 1, AnsiPos('<', S) - 1);
    end else begin
      S   :=  Copy(ALine, AnsiPos('<dt>', ALine) + 4, Length(ALine));
      S   :=  Copy(S, 1, AnsiPos(':', S) - 1);
    end;
    ARes.No :=  StrToIntDef(S, 0);

    //
    //<font color="#335544"><b></b></font>
    //<b><a href="mailto:|"><FONT COLOR = "#FF69B4">炭</font></a></b>
    S   :=  Copy(ALine, AnsiPos('OF', ALine) + 6, Length(ALine));
    S   :=  Copy(S, 1, AnsiPos('<font size="2">', S) - 1);

    sx  :=  s;
    if  (AnsiPos('<a href=mailto:', sx) > 0)  or
        (AnsiPos('<a href="mailto:', sx) > 0)  then
    begin
      sx  :=  Copy(sx, AnsiPos('mailto:', sx) + 7, Length(sx));
      if  (AnsiPos('">', sx) > 0) then  begin
        ARes.Mail :=  Copy(sx, 1, AnsiPos('">', sx) - 1);
      end else begin
        ARes.Mail :=  Copy(sx, 1, AnsiPos('>', sx) - 1);
      end;
      S :=  TrimHRefTag(S);
    end;

    ARes.Name :=  S;

    //eF2001/12/05() 02:26</font>
    S :=  Copy(ALine, AnsiPos('eF', ALine) + 8, Length(ALine));
    S :=  Trim(Copy(S, 1, AnsiPos('</font>', S) - 1));
    //eF2001/09/10() 23:27 @ <font color="#cc3681">EEE1ip</font>
    if  (AnsiPos('<font', S) > 1)  then  begin
      S :=  Trim(Copy(S, 1, AnsiPos('<font', S) - 1));
    end;
    //212chp
    if  (AnsiPos('<a', S) > 0)  then  begin
      S :=  Copy(S, 1, AnsiPos('<a', S) - 1);
    end;
    ARes.Date :=  TrimTag(S);

    //
    S :=  Copy(ALine, AnsiPos('<dd>', ALine) + 4, Length(ALine));
    if  (Copy(S, Length(S) - 2, 3) = '<p>')  then  begin
      S :=  Copy(S, 1, Length(S) - 3);
    end;
    S := TrimRight(S);
    if  (Copy(S, Length(S) - 3, 4) = '<br>')  then  begin
      S :=  Copy(S, 1, Length(S) - 4);
    end;
    ARes.Body :=  S;

    Result  :=  True;
  end else begin
    Result  :=  False;
  end;
end;

function ParseMachibbsDat(ALine: string; index: integer;
  var ARes: TRes; out ASubject: string): boolean;
begin
  Result  :=  ParseJBBSDat(ALine, index, ARes, ASubject);
end;

function Conv2chNewUrl(const OldUrl: string): string;
var
  s: string;
  bbs, key: string;
begin
  // http://piza2.2ch.net/test/read.cgi/tech/1000035521/
  // http://piza2.2ch.net/test/read.cgi?bbs=tech&key=1000035521
  s :=  Copy(OldUrl, AnsiPos('?', OldUrl) + 1, Length(OldUrl));
  //bbs=tech&key=1000035521
  bbs :=  Copy(s, AnsiPos('bbs=', s) + 4, Length(s));
  bbs :=  Copy(bbs, 1, AnsiPos('&', bbs) - 1);
  //
  key :=  Copy(s, AnsiPos('key=', s) + 4, Length(s));
  if  (AnsiPos('&', key) > 0) then  begin
    key :=  Copy(key, 1, AnsiPos('&', key) - 1);
  end else begin
    key :=  Copy(key, 1, Length(key));
  end;
  //
  s   :=  Copy(OldUrl, 1, AnsiPos('?', OldUrl) - 1);

  Result  :=  s + '/' + bbs + '/' + key + '/';
end;

function Conv2chDatUrlToReadCgiURL(const Url: string): string;
var
  n : integer;
  S, BBS, Key : string;
begin
  //http://corn.2ch.net/entrance/kako/995/995687712.html
  //http://corn.2ch.net/test/read.cgi?bbs=entrance&key=995687712
  S :=  Copy(Url,8,Length(Url));
  n :=  AnsiPos('/',S);
  S :=  Copy(S, n + 1, Length(S));
  n :=  AnsiPos('/',S);
  BBS :=  Copy(S, 1, n - 1);
  S   :=  ExtractUrlName(Url);
  n   :=  AnsiPos('.', S);
  Key :=  Copy(S, 1, n - 1);
  Result  :=  'http://' +
              ExtractHostName(Url) +
              '/test/read.cgi?bbs=' + BBS +
              '&key=' + Key;
end;

procedure Parse1_5Subject(subject: string; out FileName: string;
  out Title: string; out Count: integer);
var
  s, sx : string;
  n, m : integer;
begin
{
<td nowrap><a href="#num1"><font color=darkred>1</font></a><a href="../news/log_html/all_log111211343143.html?5"><font size=3> kNfv^f </font><font color=black></font></a>
</td><td nowrap><a href="#num2"><font color=darkred>2</font></a><a href="../news/log_html/all_log110292328373.html?5"><font size=3> V傢 </font><font color=black></font></a>
</td><td nowrap><a href="#num3"><font color=darkred>3</font></a><a href="../news/log_html/all_log11231718462.html?5"><font size=3> VZ[XQ </font><font color=black></font></a>
</td><td nowrap><a href="#num4"><font color=darkred>4</font></a><a href="../news/log_html/all_log1117856179.html?5"><font size=3> JtabZ </font><font color=black></font></a>
<a href="/inf_qa/log_html/all_log10152126433.html">[1] LOJLR (35)</a>
<a href="/inf_qa/log_html/all_log10152186514.html">[2] yً}z1.5ch.infop҂̈̂߂悤ydvz (22)</a>
<a href="/inf_qa/log_html/all_log10152457200.html">[3] u1.5chv̓ǂݕ (10)</a>
<a href="/inf_qa/log_html/all_log10152125128.html">[4] y1.5chɂ`z (20)</a>
<a href="/inf_qa/log_html/all_log10152781804.html">[5] Ȃ̓RRɂISҔ (9)</a>
}
  s :=  Copy(subject, 1, AnsiPos('">', subject) - 1);
  //<a href="../news/log_html/all_log110292328373.html
  //<a href="/inf_qa/log_html/all_log10152781804.html
  while true  do  begin
    n :=  AnsiPos('/', s);
    if  (n  >  0) then  begin
      s :=  Copy(s, n + 1, Length(s));
    end else begin
      Break;
    end;
  end;
  //all_log110292328373.html
  //all_log10152781804.html
  s  :=  Copy(s, 8, Length(s)); //all_log͂
  FileName  :=  Copy(s, 1, AnsiPos('.html', s)  -1); //gqO
  //
  Count     :=  0;
  // kNfv^f </font><font color=black></font></a>
  //[5] Ȃ̓RRɂISҔ (9)</a>
  s :=  Copy(subject, AnsiPos(']', subject) + 1, Length(subject));
  s :=  Copy(s, 1, AnsiPos('</a>', s) - 1);
  //
  sx  :=  s;
  n   :=  0;
  while true  do  begin
    m :=  AnsiPos('(', sx);
    if  (m < 1) then  Break;
    n   :=  n + m;
    sx  :=  Copy(sx, n + 1, Length(sx));
  end;
  Title :=  Trim(DecodeHtmlEsc((Copy(s, 1, n - 1))));
  Count :=  StrToIntDef(Copy(s, n + 1, Length(s) - 1 - n), 0);
  //
  //Title :=  Trim(s);
end;

procedure ParseAmezorSubject(subject: string; out FileName: string;
  out Title: string; out Count: integer);
var
  s : string;
begin
  //<font size=-1>1 <a href=../tokusetu/020126082859.html target=_blank>MRL </a> <a href="../../cgi-bin/res.cgi?dir=tokusetu&res=020126082859&ls=50">(242)</a>
  // 2 <a href=../tokusetu/011114140036.html target=_blank>IDAt@xbgȂ̂͗ǂȂ </a> <a href="../../cgi-bin/res.cgi?dir=tokusetu&res=011114140036&ls=50">(4)</a>

  //<a href="../../cgi-bin/res.cgi?dir=tokusetu&res=020126082859&ls=50">
  s :=  Copy(subject, AnsiPos('<a href="../../', subject), Length(subject));
  s :=  Copy(s, 1, AnsiPos('&ls', s) - 1);
  s :=  Copy(s, AnsiPos('res=', s) + 4, Length(s));
  FileName  :=  s;

  Count :=  0;

  s :=  Copy(subject, AnsiPos('">(', subject) + 3, Length(subject));
  s :=  Copy(s, 1, AnsiPos(')</a>', s) - 1);
  Count :=  StrToIntDef(s,0);

  s :=  Copy(subject, AnsiPos('target=_blank>', subject) + 14, Length(subject));
  s :=  Copy(s, 1, AnsiPos('<', s) - 1);
  Title :=  s;
end;

function ParseAmezorDat(ALine: string; index: integer;
  var ARes: TRes; out ASubject: string): boolean;
var
  s, sx, sxx : string;
begin
  //<head><title>Ƃ茾Ȃ炱 142 </title><meta http-equiv="Content-Type" content="text/html; charset=Shift_JIS"></head><table border=0 width=100% cellpadding=1 cellspacing=0 bgcolor="#2266dd"><tr><td align=left><font size=+1 color=white><a href="./" style="text-decoration:none;"><font color=white></font></a> <b>Ƃ茾Ȃ炱 142 </b></font></td></tr></table><dl><dt>1<font size=-1>eҁF</font><font color=forestgreen><b>JЂ </b></font><font size=-1>@eF2002N0211() 183651b</font><br><dd>1000Ŏ~߂ꂽ </dl>
  //<dl><dt>1<font size=-1>eҁF</font><font color=forestgreen><b>JЂ </b></font><font size=-1>@eF2002N0211() 183651b</font><br><dd>1000Ŏ~߂ꂽ </dl>
  ASubject  :=  '';
  if  (Length(ALine) > 0) then  begin
    if  (AnsiPos('<title>', ALine) > 0) then  begin
      S :=  Copy(ALine, AnsiPos('<title>', ALine) + 7, Length(ALine));
      ASubject  :=  Copy(S, 1, AnsiPos('</title>', S) - 1);
    end;
    //<head><title>Ƃ茾Ȃ炱 142 </title><meta http-equiv="Content-Type" content="text/html; charset=Shift_JIS"></head><table border=0 width=100% cellpadding=1 cellspacing=0 bgcolor="#2266dd"><tr><td align=left><font size=+1 color=white><a href="./" style="text-decoration:none;"><font color=white></font></a> <b>Ƃ茾Ȃ炱 142 </b></font></td></tr></table><dl><dt>1<font size=-1>eҁF</font><font color=forestgreen><b>JЂ </b></font><font size=-1>@eF2002N0211() 183651b</font><br><dd>1000Ŏ~߂ꂽ </dl>
    //<dl><dt>2<font size=-1>eҁF</font><font color=forestgreen><b>G </b></font><font size=-1>@eF2002N0211() 183733b</font><br><dd>G </dl>


    //<dl><dt>1<font size=-1>eҁF</font><font color=forestgreen><b>JЂ </b></font><font size=-1>@eF2002N0211() 183651b</font><br><dd>1000Ŏ~߂ꂽ </dl>
    //<dl><dt>2<font size=-1>eҁF</font><font color=forestgreen><b>G </b></font><font size=-1>@eF2002N0211() 183733b</font><br><dd>G </dl>

    Sx  :=  Copy(ALine,  AnsiPos('<dl><dt>', ALine) + 8, Length(ALine));
    Sx  :=  Copy(Sx, 1, AnsiPos('<font', sx) - 1);
    ARes.No :=  StrToIntDef(Sx, 0);

    //<dl><dt>1<font size=-1>eҁF</font><font color=forestgreen><b>JЂ </b></font><font size=-1>@eF2002N0211() 183651b</font><br><dd>1000Ŏ~߂ꂽ </dl>
    //<dl><dt>2<font size=-1>eҁF</font><font color=forestgreen><b>G </b></font><font size=-1>@eF2002N0211() 183733b</font><br><dd>G </dl>
    //<dl><dt>49<font size=-1>eҁF</font><font color=forestgreen><b><a href="mailto:PPolH">EP </a> </b></font><font size=-1>@eF2002N0211() 210538b</font><br><dd>NEEEIbpČ`vɁEEE </dl>
    Sx  :=  Copy(ALine, AnsiPos('<font size=-1>eҁF</font>', ALine) + 29, Length(ALine));
    Sx  :=  Copy(Sx, 1, AnsiPos('<font size=-1>', Sx) - 1);
    if  (AnsiPos('<a href="mailto:', sx) > 0)  then begin
      //<font color=forestgreen><b><a href="mailto:PPolH">EP </a> </b></font>
      sxx :=  Copy(sx, AnsiPos('mailto:', sx) + 7, Length(sx));
      ARes.Mail :=  Copy(sxx, 1, AnsiPos('">', sxx) - 1);
      Sx :=  TrimHRefTag(Sx);
    end;

    ARes.Name :=  Sx;

    //<font size=-1>@eF2002N0211() 183651b</font><br><dd>1000Ŏ~߂ꂽ </dl>
    //<font size=-1>@eF2002N0211() 183733b</font><br><dd>G </dl>
    //<font size=-1>@eF2002N0211() 210538b</font><br><dd>NEEEIbpČ`vɁEEE </dl>
    // 132320b  IDFOOh30z2c

    Sx  :=  Copy(ALine, AnsiPos('eF', ALine) + 8, Length(ALine));
    Sx  :=  Trim(Copy(Sx, 1, AnsiPos('</font>', Sx) - 1));
    if  (AnsiPos('IDF', sx) > 0) then  begin
      ARes.Date :=  Copy(sx, 1, AnsiPos('IDF', sx) - 1);
      ARes.ID   :=  Copy(sx, AnsiPos('IDF', sx) + 4, Length(sx));
    end else begin
      ARes.Date :=  Trim(Sx);
      ARes.ID   :=  '';
    end;

    //<br><dd>1000Ŏ~߂ꂽ </dl>
    //<br><dd>G </dl>
    //<dd>NEEEIbpČ`vɁEEE </dl>

    //<a href="../../cgi-bin/amezo_main.cgi?hiroba+011116235913+20" target=_blank></a></font><br><dd>炩̎ŃANZXłȂꍇ<br>[gAhXE[gzXgEŒIPǂ<br>Lă[őĂΑΏ܂B<br><br>sł傤A͑΍􂪎v܂B<br>܂񂪁A낵肢܂B</dl>
    //<dd>炩̎ŃANZXłȂꍇ<br>[gAhXE[gzXgEŒIPǂ<br>Lă[őĂΑΏ܂B<br><br>sł傤A͑΍􂪎v܂B<br>܂񂪁A낵肢܂B</dl>
    S :=  Copy(ALine, AnsiPos('<dd>', ALine) + 4, Length(ALine));
    S :=  Copy(S, 1, Length(S) - 5); //</dl>
    ARes.Body :=  S;

    Result  :=  True;
  end else begin
    Result  :=  False;
  end;
end;

procedure ParseAmex0Subject(subject: string; out FileName: string;
  out Title: string; out Count: integer);
var
  s : string;
begin
  //1<a href="020311134219.html">RN^[Xbh </a>
  //2<a href="020310023141.html">QOOP~F̗ </a>

  s :=  Copy(subject, AnsiPos('<a href="', subject) + 9, Length(subject));
  s :=  Copy(s, 1, AnsiPos('.html">', s) - 1);
  FileName  :=  s;

  Count :=  0;

  s :=  Copy(subject, AnsiPos('">', subject) + 2, Length(subject));
  s :=  Copy(s, 1, AnsiPos('</a>', s) - 1);
  Title :=  Trim(s);
end;

function ParseAmex0Dat(ALine: string; index: integer;
  var ARes: TRes; out ASubject: string): boolean;
var
  s, sx, sxx : string;
begin
  //<title>N܂ </title><dl><dt>1<font size=+2 color=red><b>N܂ </b></font>eҁF<font color=forestgreen><b>X^P </b></font><font size=-1>@eF2001N0818(y)225159b</font><br><dd>nɒ^nkƂV`G[Vz肷̂<br>ƋꂵȂH<br><a href="http://news.yahoo.co.jp/headlines/jij/010817/dom/18340000_jijdomx269.html" target=_blank>http://news.yahoo.co.jp/headlines/jij/010817/dom/18340000_jijdomx269.html</a><br><a href="http://www.koho.metro.tokyo.jp/new/tokusyu/rescue/rescue.htm" target=_blank>http://www.koho.metro.tokyo.jp/new/tokusyu/rescue/rescue.htm</a><br><a href="http://www.metro.tokyo.jp/INET/ETC/SOKUJITU/V0B8H100.PDF" target=_blank>http://www.metro.tokyo.jp/INET/ETC/SOKUJITU/V0B8H100.PDF</a> </dl>
  //<dl><dt>2eҁF<font color=forestgreen><b>@Ǘ^ </b></font><font size=-1>@eF2001N0827()232159b</font><br><dd>́AqƂ̘Ag<br><br> <a href="http://www.asahi.com/politics/update/0826/004.html" target=_blank>http://www.asahi.com/politics/update/0826/004.html</a><br>̐EǗAq̎d̓Ȃ̂ł </dl>
  ASubject  :=  '';
  if  (Length(ALine) > 0) then  begin
    if  (AnsiPos('<title>', ALine) > 0) then  begin
      S :=  Copy(ALine, AnsiPos('<title>', ALine) + 7, Length(ALine));
      ASubject  :=  Copy(S, 1, AnsiPos('</title>', S) - 1);
    end;
    //<dl><dt>1<font size=+2 color=red><b>N܂ </b></font>eҁF<font color=forestgreen><b>X^P </b></font><font size=-1>@eF2001N0818(y)225159b</font><br><dd>nɒ^nkƂV`G[Vz肷̂<br>ƋꂵȂH<br><a href="http://news.yahoo.co.jp/headlines/jij/010817/dom/18340000_jijdomx269.html" target=_blank>http://news.yahoo.co.jp/headlines/jij/010817/dom/18340000_jijdomx269.html</a><br><a href="http://www.koho.metro.tokyo.jp/new/tokusyu/rescue/rescue.htm" target=_blank>http://www.koho.metro.tokyo.jp/new/tokusyu/rescue/rescue.htm</a><br><a href="http://www.metro.tokyo.jp/INET/ETC/SOKUJITU/V0B8H100.PDF" target=_blank>http://www.metro.tokyo.jp/INET/ETC/SOKUJITU/V0B8H100.PDF</a> </dl>
    //<dl><dt>2eҁF<font color=forestgreen><b>@Ǘ^ </b></font><font size=-1>@eF2001N0827()232159b</font><br><dd>́AqƂ̘Ag<br><br> <a href="http://www.asahi.com/politics/update/0826/004.html" target=_blank>http://www.asahi.com/politics/update/0826/004.html</a><br>̐EǗAq̎d̓Ȃ̂ł </dl>
    Sx  :=  Copy(ALine,  AnsiPos('<dl><dt>', ALine) + 8, Length(ALine));
    if  (AnsiPos('<', Sx) < AnsiPos('e', sx))  then  begin
      Sx  :=  Copy(Sx, 1, AnsiPos('<', sx) - 1);
    end else begin
      Sx  :=  Copy(Sx, 1, AnsiPos('e', sx) - 1);
    end;
    ARes.No :=  StrToIntDef(Sx, 0);

    //<dl><dt>1<font size=+2 color=red><b>N܂ </b></font>eҁF<font color=forestgreen><b>X^P </b></font><font size=-1>@eF2001N0818(y)225159b</font><br><dd>nɒ^nkƂV`G[Vz肷̂<br>ƋꂵȂH<br><a href="http://news.yahoo.co.jp/headlines/jij/010817/dom/18340000_jijdomx269.html" target=_blank>http://news.yahoo.co.jp/headlines/jij/010817/dom/18340000_jijdomx269.html</a><br><a href="http://www.koho.metro.tokyo.jp/new/tokusyu/rescue/rescue.htm" target=_blank>http://www.koho.metro.tokyo.jp/new/tokusyu/rescue/rescue.htm</a><br><a href="http://www.metro.tokyo.jp/INET/ETC/SOKUJITU/V0B8H100.PDF" target=_blank>http://www.metro.tokyo.jp/INET/ETC/SOKUJITU/V0B8H100.PDF</a> </dl>
    //<dl><dt>2eҁF<font color=forestgreen><b>@Ǘ^ </b></font><font size=-1>@eF2001N0827()232159b</font><br><dd>́AqƂ̘Ag<br><br> <a href="http://www.asahi.com/politics/update/0826/004.html" target=_blank>http://www.asahi.com/politics/update/0826/004.html</a><br>̐EǗAq̎d̓Ȃ̂ł </dl>
    //<dl><dt>7eҁF<font color=forestgreen><b><a href="mailto:sage">R{B </a> </b></font><font size=-1>@eF2001N0517()182049b</font><br><dd>ȂƂA肽܂AL~BB </dl>

    Sx  :=  Copy(ALine, AnsiPos('eҁF', ALine) + 8, Length(ALine));
    Sx  :=  Copy(Sx, 1, AnsiPos('<font size=-1>', Sx) - 1);
    if  (AnsiPos('<a href="mailto:', sx) > 0)  then begin
      //<font color=forestgreen><b><a href="mailto:PPolH">EP </a> </b></font>
      sxx :=  Copy(sx, AnsiPos('mailto:', sx) + 7, Length(sx));
      ARes.Mail :=  Copy(sxx, 1, AnsiPos('">', sxx) - 1);
      Sx :=  TrimHRefTag(Sx);
    end;

    ARes.Name :=  Sx;

    //<font size=-1>@eF2001N0818(y)225159b</font><br><dd>nɒ^nkƂV`G[Vz肷̂<br>ƋꂵȂH<br><a href="http://news.yahoo.co.jp/headlines/jij/010817/dom/18340000_jijdomx269.html" target=_blank>http://news.yahoo.co.jp/headlines/jij/010817/dom/18340000_jijdomx269.html</a><br><a href="http://www.koho.metro.tokyo.jp/new/tokusyu/rescue/rescue.htm" target=_blank>http://www.koho.metro.tokyo.jp/new/tokusyu/rescue/rescue.htm</a><br><a href="http://www.metro.tokyo.jp/INET/ETC/SOKUJITU/V0B8H100.PDF" target=_blank>http://www.metro.tokyo.jp/INET/ETC/SOKUJITU/V0B8H100.PDF</a> </dl>
    //<font size=-1>@eF2001N0827()232159b</font><br><dd>́AqƂ̘Ag<br><br> <a href="http://www.asahi.com/politics/update/0826/004.html" target=_blank>http://www.asahi.com/politics/update/0826/004.html</a><br>̐EǗAq̎d̓Ȃ̂ł </dl>
    //<font size=-1>@eF2001N0517()182049b</font><br><dd>ȂƂA肽܂AL~BB </dl>

    Sx  :=  Copy(ALine, AnsiPos('eF', ALine) + 8, Length(ALine));
    Sx  :=  Trim(Copy(Sx, 1, AnsiPos('</font>', Sx) - 1));
    ARes.Date :=  Trim(Sx);

    //<br><dd>nɒ^nkƂV`G[Vz肷̂<br>ƋꂵȂH<br><a href="http://news.yahoo.co.jp/headlines/jij/010817/dom/18340000_jijdomx269.html" target=_blank>http://news.yahoo.co.jp/headlines/jij/010817/dom/18340000_jijdomx269.html</a><br><a href="http://www.koho.metro.tokyo.jp/new/tokusyu/rescue/rescue.htm" target=_blank>http://www.koho.metro.tokyo.jp/new/tokusyu/rescue/rescue.htm</a><br><a href="http://www.metro.tokyo.jp/INET/ETC/SOKUJITU/V0B8H100.PDF" target=_blank>http://www.metro.tokyo.jp/INET/ETC/SOKUJITU/V0B8H100.PDF</a> </dl>
    //<br><dd>́AqƂ̘Ag<br><br> <a href="http://www.asahi.com/politics/update/0826/004.html" target=_blank>http://www.asahi.com/politics/update/0826/004.html</a><br>̐EǗAq̎d̓Ȃ̂ł </dl>
    //<br><dd>ȂƂA肽܂AL~BB </dl>

    //<br><dd>1000Ŏ~߂ꂽ </dl>
    //<br><dd>G </dl>
    //<dd>NEEEIbpČ`vɁEEE </dl>

    S :=  Copy(ALine, AnsiPos('<dd>', ALine) + 4, Length(ALine));
    S :=  Copy(S, 1, Length(S) - 5); //</dl>
    ARes.Body :=  S;

    Result  :=  True;
  end else begin
    Result  :=  False;
  end;
end;

function ParseShitarabaJbbsDat(ALine: string; index: integer;
  var ARes: TRes; out ASubject: string): boolean;
var
  s: string;
  n: integer;
begin
  //S  =  GikoCopy(Data, 1, GikoPos("OF", Data) - 1)
  s :=  Copy(ALine, 1, AnsiPos('OF', ALine) - 1);
  //S  =  GikoTrim(GikoCopy(S, 5, GikoLen(S)))
  s :=  TrimTag(Copy(s, 5, Length(s)));
  //ResNo = S
  ARes.No := StrToIntDef(s, 0);

  //S  =  GikoCopy(Data, 1, GikoPos("<b>", Data) - 1)
  s :=  Copy(ALine, 1, AnsiPos('<b>', ALine) - 1);
  //Ӽ GikoPos('<a href="mailto:', S) > 1 ޯ ּ ParseResMail
  //ּ ParseResName
  if  (AnsiPos('<a href="mailto:', s) > 1)  then  begin
    //Ҽټ ParseResMail
    //S = GikoCopy(Data, GikoPos('<a href="mailto:', Data) + 16, GikoLen(Data))
    s :=  Copy(ALine, AnsiPos('<a href="mailto:', ALine) + 16, Length(ALine));
    //S = GikoCopy(S, 1, GikoPos('">', S) - 1)
    s :=  Copy(s, 1, AnsiPos('">', s) - 1);
    //ResMail = S
    ARes.Mail :=  s;
    //S = GikoCopy(Data, GikoPos("<b>", Data), GikoLen(Data))
    s :=  Copy(ALine, AnsiPos('<b>', ALine), Length(ALine));
    //S = GikoCopy(S, 1, GikoPos("</b>", S) + 3)
    s :=  Copy(s, 1, AnsiPos('</b>', AnsiLowerCase(s)) + 3);
    //Ӽ GikoTrim(S) = "<b> </b>" ޯ ּ ParseResLinkName
    if  (Trim(s) = '<b> </b>')  then  begin
      //ParseResLinkName
      //Ҽټ ParseResLinkName
      //S = GikoCopy(Data, GikoPos("<b>", Data), GikoLen(Data))
      s :=  Copy(ALine, AnsiPos('<b>', ALine), Length(ALine));
      //S = GikoCopy(S, 1, GikoPos("</a>", S) - 1)
      s :=  Copy(s, 1, AnsiPos('</a>', s) - 1);
      //ResName = S
      ARes.Name := s;
      //ּ ParseResDate
    end else begin
      //ResName = S
      ARes.Name := s;
      //ּ ParseResDate
    end;
  end else begin
    //Ҽټ ParseResName
    //S = GikoCopy(Data, GikoPos("<font", Data), GikoLen(Data))
    s :=  Copy(ALine, AnsiPos('<font', ALine), Length(ALine));
    //n = GikoPos("eF", S) - 1
    n :=  AnsiPos('eF', s) - 1;
    //S = GikoCopy(S, 1, n)
    s :=  Copy(s, 1, n);
    //ResName = S
    ARes.Name := s;
  end;
  //Ҽټ ParseResDate
  //S = GikoCopy(Data, GikoPos("eF", Data) + 8, GikoLen(Data))
  s :=  Copy(ALine, AnsiPos('eF', ALine) + 8, Length(ALine));
  //S = GikoCopy(S, 1, GikoPos("<br>", S) - 1)
  s :=  Copy(s, 1, AnsiPos('<br>', s) - 1);
  //ResDate = S
  ARes.Date :=  s;
  //
  //Ҽټ ParseResBody
  //S = GikoCopy(Data, GikoPos("<dd>", Data) + 4, GikoLen(Data))
  s :=  Copy(ALine, AnsiPos('<dd>', ALine) + 4, Length(ALine));
  //S = GikoCopy(S, 1, GikoLen(S) - 8)
  s :=  Copy(s, 1, Length(s) - 8);
  //ResBody = S
  ARes.Body :=  s;
  //
  //Ҽټ ParseEnd
  //ParseOk = OK
  //ּ ExitProc
end;

function ConvShitarabaJbbsUrl(const Url: string): string;
var
  n : integer;
  s, r,stx, tox, nof : string;
  DatNo : string;
begin
  n :=  AnsiPos('/read.cgi/', Url);
  if  (n > 0) then  begin

    //*http://jbbs.shitaraba.com/bbs/read.cgi/computer/351/1040452916/127
    // http://piza2.2ch.net/test/read.cgi/tech/1000035521/
    // http://piza2.2ch.net/test/read.cgi?bbs=tech&key=1000035521

    s := Copy(Url, n + 1, Length(Url));
    //*s =  read.cgi/computer/351/1040452916/127
    // s =  read.cgi/tech/1000035521/
    r  :=  Copy(Url, 1, n) + 'read.cgi' +
                             '?BBS=' + ChooseString(s, '/', 2) +
                             '&KEY=' + ChooseString(s, '/', 3);
    s :=  ChooseString(s, '/', 4);
    if  (AnsiPos('-', s) > 0)  then  begin
      stx :=  ChooseString(s, '-', 0);
      tox :=  ChooseString(s, '-', 1);
      if  (AnsiPos('n', tox) > 0) then  begin
        tox :=  StringReplace(tox, 'n', '', [rfReplaceAll]);
        nof :=  '&NOFIRST=true';
      end else begin
        nof :=  '';
      end;
      if  (stx <> '') then  r :=  r + '&START=' + stx;
      if  (tox <> '') then  r :=  r + '&END=' + tox;
    end else
    if  (s <> '') then  begin
      if  (AnsiPos('n', s) > 0) then  begin
        s   :=  StringReplace(s, 'n', '', [rfReplaceAll]);
        nof :=  '&NOFIRST=true';
      end else begin
        nof :=  '';
      end;
      stx :=  s;
      tox :=  s;
      r :=  r + '&START=' + stx;
      r :=  r + '&END=' + tox;
    end;
    Result  :=  r + nof;
  end else  begin
    Result  :=  Url;
  end;
  {
  //http://teri.2ch.net/accuse/kako/998/998759338.html
  //http://piza.2ch.net/log/sci/kako/939/939217336.html
  //http://teri.2ch.net/test/read.cgi?bbs=accuse&key=998759338
  if  (AnsiPos('/kako/', Url) > 0)  then  begin
    DatNo :=  ExtractUrlName(Url);
    if  (AnsiPos('.htm', DatNo) > 0)  then  begin
      DatNo :=  Copy(DatNo, 1, AnsiPos('.htm', DatNo) - 1);
    end;
    s :=    ChooseString(Url, '/', 3);
    if  (SameText(s, 'log')) then  begin
      s :=  ChooseString(Url, '/', 4);
    end;
    Result  :=  'http://' +
                ExtractHostName(Url) + '/test/read.cgi' +
                '?bbs=' + s +
                '&key=' + DatNo
  end else begin
    Result  :=  Url;
  end;
  }
end;

end.

